############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXNODE, NX protocol compression and NX extensions to this software      #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package Common::NXProcess;no warnings;($NXProcess::children={});(
$NXProcess::childrenData={});($NXProcess::finishedChildren={});(
$NXProcess::childFinishedWithSignal={});($NXProcess::childrenExitCallback={});(
$NXProcess::childrenErrorCallback={});($NXProcess::childrenToLeave={});(
$NXProcess::watchDogList={});($NXProcess::finishedWatchDogList={});(
$NXProcess::watchDogToLeaveList={});($NXProcess::watchDogAsSuperuser={});(
$NXProcess::errorNoProcessToWait=(-(0x03b8+ 4910-0x16e5)));(
$NXProcess::statusRunning=(0x1ef0+ 156-0x1f8c));($NXProcess::statusExited=
(0x0818+ 5955-0x1f5a));($NXProcess::signalKill=(0x11d6+ 4346-0x22c7));(
$NXProcess::signalTerm=(0x14b7+ 2303-0x1da7));($NXProcess::signalSegv=
(0x1420+ 421-0x15ba));($NXProcess::processTree=(0x1e6c+ 1129-0x22d4));(
$NXProcess::noProcessTree=(0x07ef+ 4321-0x18d0));sub nxProcessCreate{(my $filename
=shift (@_));(my $command=shift (@_));(my $environment=shift (@_));(my $stdin=
shift (@_));(my $stdout=shift (@_));(my $stderr=shift (@_));(my $priority=shift 
(@_));my ($pid);my ($pidOrHandle);Logger::debug (((((((((((((((
"\x6e\x78\x50\x72\x6f\x63\x65\x73\x73\x43\x72\x65\x61\x74\x65\x3a\x20\x27".
$filename)."\x27\x20\x27").join ($",@$command))."\x27\x20\x27").join ($",
@$environment))."\x27\x20\x27\x46\x44\x23").$stdin)."\x27\x20\x27\x46\x44\x23").
$stdout)."\x27\x20\x27\x46\x44\x23").$stderr)."\x27\x20\x27").$priority)."\x27")
);($pidOrHandle=libnxh::NXProcessCreate ($filename,$command,$environment,$stdin,
$stdout,$stderr,$priority));if (($pidOrHandle==(-(0x0799+ 855-0x0aef)))){
Common::NXCore::reportErrorFromNXPL (((((((((((((((((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x43\x72\x65\x61\x74\x65\x28".$filename).
"\x2c\x20").$command)."\x2c\x20").$environment)."\x2c\x20").$stdin)."\x2c\x20").
$stdout)."\x2c\x20").$stderr)."\x2c\x20").$priority).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$pidOrHandle)."\x2e"));return ((-(0x0499+ 4914-0x17ca)));}($pid=
handleProcessHandle ($pidOrHandle));addChild ($pid);(my $commandLine=$filename);
foreach my $parameter (@$command){if (($parameter eq $filename)){next;}else{(
$commandLine.=("\x20".$parameter));}}registerChildName ($commandLine,$pid);
return ($pid);}sub nxProcessExec{(my $filename=shift (@_));(my $command=shift (
@_));(my $environment=shift (@_));(my $ref_error=shift (@_));Logger::debug (((((
(("\x6e\x78\x50\x72\x6f\x63\x65\x73\x73\x45\x78\x65\x63\x3a\x20\x27".$filename).
"\x27\x20\x27").join ($",@$command))."\x27\x20\x27").join ($",@$environment)).
"\x27"));(my $result=libnxh::NXProcessExec ($filename,$command,$environment));if
 (($result==(-(0x0cf7+ 3973-0x1c7b)))){Common::NXCore::reportErrorFromNXPL (((((
(((("\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x45\x78\x65\x63\x28".$filename).
"\x2c\x20").$command)."\x2c\x20").$environment).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$result)."\x2e"));($$ref_error=libnxh::NXGetErrorString ());return (
(0x0798+ 7726-0x25c6));}return ((0x085d+ 1166-0x0cea));}sub handleProcessHandle{
(my $pidOrHandle=shift (@_));return ($pidOrHandle);(my $pid=getPidFromHandle (
$pidOrHandle));($NXProcess::processPidsArrayByHandle{$pidOrHandle}=$pid);(
$NXProcess::processHandlesArrayByPid{$pid}=$pidOrHandle);return ($pid);}sub 
getPidFromHandle{(my $handle=shift (@_));(my $pid=libnxh::NXConvertHandlerToPid 
($handle));Logger::debug (((((
"\x67\x65\x74\x50\x69\x64\x46\x72\x6f\x6d\x48\x61\x6e\x64\x6c\x65\x3a\x20\x68\x61\x6e\x64\x6c\x65\x20\x5b"
.$handle).
"\x5d\x20\x63\x6f\x6e\x76\x65\x72\x74\x65\x64\x20\x74\x6f\x20\x70\x69\x64\x20\x5b"
).$pid)."\x5d\x2e"));return ($pid);}sub convertToHandleIfNeeded{(my $pid=shift (
@_));return ($pid);if (defined ($NXProcess::processHandlesArrayByPid{$pid})){(my $handle
=$NXProcess::processHandlesArrayByPid{$pid});if (($pid==
$NXProcess::processPidsArrayByHandle{$handle})){return ($handle);}}return ($pid)
;}sub checkIsProcessFinished{(my $pid=shift (@_));if (($pid>
(0x037b+ 7985-0x22ac))){if ((not (isChildProcess ($pid)))){if (isChildFinished (
$pid)){return ((0x0929+ 5985-0x2089));}if ((not (isOnWatchdogProcess ($pid)))){
if (isFinishedWatchDog ($pid)){return ((0x05a4+ 7770-0x23fd));}return ((-
(0x05c4+ 169-0x066c)));}}}if (($pid==(0x0248+ 1736-0x0910))){return ((-
(0x1028+ 4393-0x2150)));}return ((0x0d87+ 5146-0x21a1));}sub 
checkForWaitingEventForPid{(my $pid=shift (@_));(my $childrenList=
$NXProcess::children);if (($pid==(-(0x144c+ 170-0x14f5)))){foreach my $listpid (
keys (%$childrenList)){if (isChildFinished ($listpid)){return ($listpid);}else{
next;}}return ((0x0332+ 453-0x04f7));}elsif (($pid>(0x1425+ 3142-0x206b))){if (
isChildProcess ($pid)){if (isChildFinished ($pid)){return ($pid);}else{return (
(0x0202+ 499-0x03f5));}}else{if (isChildFinished ($pid)){return ($pid);}if (
isFinishedWatchDog ($pid)){return ($pid);}if (isOnWatchdogProcess ($pid)){return
 ((0x002d+ 9905-0x26de));}return ((-(0x1e2a+ 605-0x2086)));}}return ((-
(0x0d61+ 5281-0x2201)));}sub nxwaitpid{(my $pid=shift (@_));(my $options=(shift 
(@_)||$NXBits::WAIT_NOHANG));(my $timeout=(shift (@_)||"\x69\x6e\x66"));(my $startwaitpid
=Common::NXTime::getSecondsSinceEpoch ());(my $sigpid=(-(0x127a+ 1926-0x19ff)));my (
$status);my ($nxplreturn);(my $finished=checkIsProcessFinished ($pid));if ((
$finished!=(0x066b+ 2602-0x1095))){if (($finished==(-(0x1c19+ 327-0x1d5f)))){
return ((-(0x097c+ 5738-0x1fe5)));}return ($pid);}(my $selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;(my $signalFd=$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});$selector->add (
$signalFd);if (($options==$NXBits::WAIT_UNTRACED)){while ((0x1799+ 2277-0x207d))
{if (($timeout eq "\x69\x6e\x66")){Common::NXCore::exitFromSelectOnFirstSignal 
();(my (@ready)=$selector->can_read);
Common::NXCore::disableExitFromSelectOnFirstSignal ();}else{if (($timeout<=
(0x08f5+ 3822-0x17e3))){return ((0x1137+ 1813-0x184c));}
Common::NXCore::exitFromSelectOnFirstSignal ();(my (@ready)=$selector->can_read 
(($timeout *(0x11f8+ 816-0x1140))));
Common::NXCore::disableExitFromSelectOnFirstSignal ();($timeout=($timeout-(
Common::NXTime::getSecondsSinceEpoch ()-$startwaitpid)));}(my $check=
checkForWaitingEventForPid ($pid));if (((!$check)==(0x03c1+ 7337-0x206a))){
return ($check);}}}else{(my (@ready)=$selector->can_read ((0x0724+ 7203-0x2347),
"\x73\x69\x6c\x65\x6e\x74"));(my $waitingEvent=checkForWaitingEventForPid ($pid)
);return ($waitingEvent);}}sub nxChildProcessCheck{(my $pid=shift (@_));(my $status
=(0x17fd+ 2949-0x2382));(my $exit=(0x23df+ 487-0x25c6));my ($nxplreturn);(my $pidToNxpl
=convertToHandleIfNeeded ($pid));($nxplreturn=libnxh::NXProcessCheck ($pidToNxpl
,$status));if (($nxplreturn==(-(0x12f8+ 4936-0x263f)))){(my $errname=
libnxh::NXGetErrorName ());Logger::warning (((((((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x28".$pid)
."\x2f").$pidToNxpl).
"\x29\x20\x77\x69\x74\x68\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x43\x68\x65\x63\x6b\x20\x66\x61\x69\x6c\x65\x64\x20\x77\x69\x74\x68\x20\x65\x72\x72\x6f\x72\x20\x27"
).$errname)."\x27\x2e"));}sub BEGIN{require POSIX;do{"\x50\x4f\x53\x49\x58"->
import ("\x3a\x73\x79\x73\x5f\x77\x61\x69\x74\x5f\x68")};}if (($nxplreturn==
(0x0183+ 5450-0x16cd))){if (WIFEXITED ($status)){($exit=WEXITSTATUS ($status));
setChildExitCode ($pid,$exit);}if (WIFSIGNALED ($status)){($exit=WTERMSIG (
$status));setChildExitSignal ($pid,$exit);}}return ($nxplreturn);}sub sigterm{(my $process_pid
=shift (@_));if (libnxh::NXProcessRunning ($process_pid)){my ($result);if (
isChildProcess ($process_pid)){Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($result=libnxh::NXProcessKill ($process_pid,$NXBITS::SIGTERM));}else{
Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($result=libnxh::NXKillProcess ($process_pid,$NXBITS::SIGTERM));}if (($result
==(-(0x165c+ 2802-0x214d)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x0446+ 6807-0x1edd));}else{Logger::debug (((((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$result)."\x2e"));return ((0x06c4+ 6979-0x2206));}}Logger::debug (((
"\x54\x65\x72\x6d\x69\x6e\x61\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x54\x45\x52\x4d\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));return ((0x2558+ 419-0x26fa));}sub winKillTreeProcess{return (
(0x19e3+ 2305-0x22e3));}sub sigkill{(my $process_pid=shift (@_));(my $process_tree
=(shift (@_)||(0x04aa+ 6305-0x1d4b)));if ((not (defined ($process_pid)))){
Logger::warning (
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x62\x75\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"
);return ((0x10b8+ 909-0x1445));}if ((($process_pid==(0x122f+ 4616-0x2437))or (
$process_pid==$ $))) {
 main::nxexit (getSignalKill ());}(my $pidToNxpl=
convertToHandleIfNeeded ($process_pid));(my $status=isProcessRunning (
$process_pid));if ($status){my ($return);if (isChildProcess ($process_pid)){
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXProcessKill ($pidToNxpl,getSignalKill ()));}else{if ((
$process_tree==(0x1513+ 3463-0x229a))){Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXKillProcess ($process_pid,getSignalKill ()));}else{
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x74\x72\x65\x65\x2e"
));($return=libnxh::NXKillTree ($process_pid,getSignalKill ()));}}if (($return==
(-(0x06a7+ 6361-0x1f7f)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x0287+ 1111-0x06de));}else{Logger::debug (((((
(("\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".
$process_pid)."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$return)."\x2e"));return ((0x2077+ 141-0x2103));}}else{Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x4b\x49\x4c\x4c\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));}return ((0x0727+ 1166-0x0bb4));}sub sigSegv{(my $process_pid=shift (@_));if 
((not (defined ($process_pid)))){Logger::warning (
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x20\x62\x75\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2e"
);return ((0x1210+ 1157-0x1695));}(my $pidToNxpl=convertToHandleIfNeeded (
$process_pid));(my $status=isProcessRunning ($process_pid));if ($status){my (
$return);if (isChildProcess ($process_pid)){Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXProcessKill ($pidToNxpl,getSignalSegv ()));}else{
Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x73\x69\x67\x6e\x61\x6c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x6e\x6f\x74\x20\x61\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));($return=libnxh::NXKillProcess ($process_pid,getSignalSegv ()));}if (($return
==(-(0x1547+ 3257-0x21ff)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x53\x45\x47\x56\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$process_pid)."\x2e"));return ((0x0071+ 3486-0x0e0f));}else{Logger::debug (((((
(("\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".
$process_pid)."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20"
).$return)."\x2e"));return ((0x00bd+ 8064-0x203c));}}else{Logger::debug (((((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$process_pid)
."\x2f").$pidToNxpl).
"\x20\x75\x73\x69\x6e\x67\x20\x53\x49\x47\x53\x45\x47\x56\x2c\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));}return ((0x0c1b+ 5726-0x2278));}sub signalProcessByRestrictedScript{(my $pid
=shift (@_));(my $signal=shift (@_));(my $tree=shift (@_));(my $nxkillScript=
"\x6e\x78\x6b\x69\x6c\x6c\x2e\x73\x68");(my (@command)=(
Common::NXCore::getNXExecCommand (),$nxkillScript,$pid,$signal,$tree));(my (
@parameters)=());main::run_command ((\@command),(\@parameters));}sub 
sendTerminateWaitAndKill{(my $processPid=shift (@_));(my $sleepTime=(shift (@_)
||(0x0234+ 6551-0x1bca)));if ((($processPid==(0x0cc8+ 1763-0x13ab))or (not (
defined ($processPid))))){Logger::debug (((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x70\x69\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x27"
.$processPid)."\x27\x2e"));return ((0x02e8+ 2493-0x0ca5));}if (isProcessRunning 
($processPid)){Logger::debug (((
"\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20\x27\x31\x35\x27"));if 
(sigterm ($processPid)){Logger::debug (((
"\x53\x49\x47\x54\x45\x52\x4d\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime)
;if (isProcessRunning ($processPid)){if (sigkill ($processPid)){Logger::debug ((
(
"\x53\x49\x47\x4b\x49\x4c\x4c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x63\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub leaveOrphans{foreach my $pid (keys (%$NXProcess::childrenToLeave)){(my $pidToNxpl
=convertToHandleIfNeeded ($pid));(my $result=libnxh::NXForceRemove ($pidToNxpl))
;if (($result==(-(0x1603+ 2493-0x1fbf)))){Common::NXCore::reportErrorFromNXPL ((
(((
"\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6f\x72\x63\x65\x20\x72\x65\x6d\x6f\x76\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x2f").$pidToNxpl)."\x2e"));}else{Logger::debug (((((
"\x4c\x65\x66\x74\x20\x70\x72\x6f\x63\x65\x73\x73\x20".$pid)."\x2f").$pidToNxpl)
."\x20\x61\x73\x20\x6f\x72\x70\x68\x61\x6e\x2e"));}}foreach my $pid (keys (
%$NXProcess::watchDogList)){(my $result=libnxh::NXRemoveWatchdog ($pid));if ((
$result==(-(0x0cab+ 4340-0x1d9e)))){Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x2e"));}else{Logger::debug (((((
"\x52\x65\x6d\x6f\x76\x65\x64\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6f\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid)."\x20\x77\x69\x74\x68\x20\x72\x65\x73\x75\x6c\x74\x20\x27").$result).
"\x27\x2e"));}}}sub leaveChildAtFinish{(my $pid=shift (@_));if (isChildProcess (
$pid)){Logger::debug (((
"\x53\x65\x74\x74\x69\x6e\x67\x20\x63\x68\x69\x6c\x64\x20".$pid).
"\x20\x74\x6f\x20\x62\x65\x20\x6c\x65\x66\x74\x20\x61\x66\x74\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x65\x6e\x64\x73\x2e"
));($$NXProcess::childrenToLeave{$pid}=(0x1cb8+ 453-0x1e7c));}}sub 
leaveWatchdogAtFinish{(my $pid=shift (@_));($$NXProcess::watchDogToLeaveList{
$pid}=(0x0359+ 5166-0x1786));}sub removeFromLeaveWatchdogAtFinishList{(my $pid=
shift (@_));delete ($$NXProcess::watchDogToLeaveList{$pid});}sub 
addToWatchDogList{(my $pid=shift (@_));($$NXProcess::watchDogList{$pid}=
(0x04fc+ 4645-0x1720));delete ($$NXProcess::finishedWatchDogList{$pid});}sub 
handleWatchDogSIG{foreach my $pid (keys (%$NXProcess::watchDogList)){
Logger::debug3 (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x2e"));if ((not (libnxh::NXProcessRunning ($pid)))){Logger::debug (
(("\x4e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"));
(my $callback=$$NXProcess::childrenExitCallback{$pid});Logger::debug (((((
"\x45\x78\x65\x63\x75\x74\x69\x6e\x67\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x27"
.$callback)."\x27\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27").$pid
)."\x2e\x27"));delete ($$NXProcess::watchDogList{$pid});libnxh::NXRemoveWatchdog
 ($pid);($$NXProcess::finishedWatchDogList{$pid}=(0x01f0+ 6846-0x1cad));if ((
$callback ne (""))){&{$callback;}($pid,(0x1e08+ 1957-0x25ad));}}}}sub 
setCallbackSIGCHLD{(my $pid=shift (@_));(my $callback=shift (@_));(
$$NXProcess::childrenExitCallback{$pid}=$callback);(
$$NXProcess::childrenErrorCallback{$pid}=$callback);if (((not (isChildProcess (
$pid)))and (not (isOnWatchdogProcess ($pid))))){addToWatchDogList ($pid);}
Logger::debug2 ((((("\x4e\x65\x77\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x5b".
$$NXProcess::childrenExitCallback{$pid}).
"\x5d\x20\x66\x6f\x72\x20\x53\x49\x47\x43\x48\x49\x4c\x44\x20\x66\x6f\x72\x20\x70\x69\x64\x20\x5b"
).$pid)."\x5d"));}sub setExitCallback{(my $pid=shift (@_));(my $callback=shift (
@_));($$NXProcess::childrenExitCallback{$pid}=$callback);}sub setErrorCallback{(my $pid
=shift (@_));(my $callback=shift (@_));($$NXProcess::childrenErrorCallback{$pid}
=$callback);}sub addWatchdog{(my $pid=shift (@_));if (((not (defined ($pid)))or 
($pid==(0x00bd+ 3472-0x0e4d)))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x61\x64\x64\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x50\x49\x44\x20\x27"
.$pid)."\x27\x2e"));return ((-(0x02e1+ 9163-0x26ab)));}if (isOnWatchdogProcess (
$pid)){Logger::warning ((("\x50\x72\x6f\x63\x65\x73\x73\x20\x50\x49\x44\x20\x27"
.$pid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x6f\x6e\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x20\x6c\x69\x73\x74\x2e"
));return ((0x1448+ 2406-0x1dae));}Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x41\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x28"
.$pid)."\x2c\x20").$NXBITS::SIGCHLD)."\x29\x2e"));(my $result=
libnxh::NXAddWatchdog ($pid,$NXBITS::SIGCHLD));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x41\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$result)."\x27\x2e"));addToWatchDogList ($pid);setCallbackSIGCHLD ($pid,(
\&nxDefaultWatchdogExitHandler));return ((0x00ec+ 5573-0x16b1));}sub addChild{(my $pid
=(shift (@_)||(0x0302+ 1461-0x08b7)));if (($pid<=(0x18c7+ 2175-0x2146))){
Logger::warning (((
"\x54\x72\x79\x69\x6e\x67\x20\x74\x6f\x20\x61\x64\x64\x20\x77\x72\x6f\x6e\x67\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x2e"));return;}if ((not (isChildProcess ($pid)))){(my $pidToNxpl=
convertToHandleIfNeeded ($pid));(my $nxplreturn=libnxh::NXProcessAdd ($pidToNxpl
));($$NXProcess::children{$pid}=(0x0e2d+ 3450-0x1ba6));Logger::debug (((((
"\x41\x64\x64\x65\x64\x20\x27".$pid)."\x2f").$pidToNxpl).
"\x27\x20\x74\x6f\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6c\x69\x73\x74\x2e"))
;($$NXProcess::childrenExitCallback{$pid}=(\&nxDefaultExitCodeHandler));(
$$NXProcess::childrenErrorCallback{$pid}=(\&nxDefaultExitCodeHandler));(
$$NXProcess::childFinishedWithSignal{$pid}=(0x0466+ 8434-0x2558));if (
isChildFinished ($pid)){delete ($$NXProcess::finishedChildren{$pid});}if (
isFinishedWatchDog ($pid)){delete ($$NXProcess::finishedWatchDogList{$pid});}}
else{Logger::debug (((
"\x54\x72\x79\x69\x6e\x67\x20\x74\x6f\x20\x61\x64\x64\x20\x73\x61\x6d\x65\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x20\x61\x73\x20\x63\x68\x69\x6c\x64\x2e"));}}sub 
nxDefaultExitCodeHandler{(my $pid=shift (@_));(my $code=shift (@_));
Logger::debug (((
"\x6e\x78\x44\x65\x66\x61\x75\x6c\x74\x45\x78\x69\x74\x43\x6f\x64\x65\x48\x61\x6e\x64\x6c\x65\x72\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$pid)."\x20\x6a\x75\x73\x74\x20\x64\x69\x65\x64\x2e"));}sub 
nxDefaultWatchdogExitHandler{(my $pid=shift (@_));Logger::debug (((
"\x6e\x78\x44\x65\x66\x61\x75\x6c\x74\x57\x61\x74\x63\x68\x64\x6f\x67\x45\x78\x69\x74\x48\x61\x6e\x64\x6c\x65\x72\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x5b"
.$pid)."\x5d\x20\x6a\x75\x73\x74\x20\x64\x69\x65\x64\x2e"));}sub removechild{(my $pid
=shift (@_));if (isChildProcess ($pid)){Logger::debug (((
"\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x63\x61\x6c\x6c\x20\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x65\x6d\x6f\x76\x65\x28"
.$pid)."\x29"));(my $pidToNxpl=convertToHandleIfNeeded ($pid));(my $nxplreturn=
libnxh::NXProcessRemove ($pidToNxpl));if (($nxplreturn==(-(0x1033+ 2819-0x1b35))
)){Common::NXCore::reportErrorFromNXPL (((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x65\x6d\x6f\x76\x65\x28".$pidToNxpl).
"\x29\x20\x66\x61\x69\x6c\x65\x64\x2e"));}(my ($name,$lifetime)=
getChildNameAndLifetime ($pid));if (processTerminatedBySignal ($pid)){(my $exitSignal
=getChildExitSignal ($pid));if (($exitSignal!=$NXBITS::SIGTERM)){Logger::warning
 ((((((((((("\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20"
).$exitSignal)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}else{Logger::debug (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x73\x69\x67\x6e\x61\x6c\x20"
).$exitSignal)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}}else{(my $exitCode=getChildExitCode (
$pid));if (($exitCode==(0x0d46+ 5828-0x240a))){Logger::debug (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$exitCode)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}else{Logger::warning (((((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$name).
"\x27\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27").$pid)."\x2f").$pidToNxpl).
"\x27\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x77\x69\x74\x68\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20"
).$exitCode)."\x20\x61\x66\x74\x65\x72\x20").$lifetime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));}}delete ($$NXProcess::children{$pid});
}if (exists ($$NXProcess::childrenToLeave{$pid})){delete (
$$NXProcess::childrenToLeave{$pid});}}sub isProcessRunning{(my $pid=shift (@_));
if (((not (defined ($pid)))or ($pid<=(0x1cb0+ 2151-0x2517)))){return (
(0x0f64+ 3097-0x1b7d));}if (($pid==$ $)) {
 return ((0x23c4+ 283-0x24de));}if (
isChildProcess ($pid)){return ((0x0944+ 3041-0x1524));}(my $pidToNxpl=
convertToHandleIfNeeded ($pid));(my $ret=libnxh::NXProcessRunning ($pidToNxpl));
if (($ret==(-(0x0347+ 5043-0x16f9)))){(my $errname=libnxh::NXGetErrorName ());if
 ((($errname eq "\x45\x41\x43\x43\x45\x53")or ($errname eq 
"\x45\x50\x45\x52\x4d"))){return ((0x115a+ 3905-0x209a));}Logger::warning ((((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x68\x65\x63\x6b\x20\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x52\x75\x6e\x6e\x69\x6e\x67\x28"
.$pid)."\x2f").$pidToNxpl)."\x29\x20\x3a\x20").$errname));return (
(0x02e8+ 603-0x0543));}return ($ret);}sub handleSIGUSR1{Logger::debug (
"\x68\x61\x6e\x64\x6c\x65\x53\x49\x47\x55\x53\x52\x31",(0x03a0+ 8331-0x242b));if
 (defined ($NXBegin::handlerSIGUSR1)){if (($NXBegin::handlerSIGUSR1 ne (""))){
Logger::debug (("\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x63\x61\x6c\x6c\x3a\x20".
$NXBegin::handlerSIGUSR1),(0x05b8+ 4456-0x1720));&$NXBegin::handlerSIGUSR1 ();}}
else{Logger::debug ("\x49\x67\x6e\x6f\x72\x69\x6e\x67\x20\x55\x53\x52\x31",
(0x02ac+ 8670-0x248a));}}sub handleSIGCHLD{(my $children=$NXProcess::children);my (
$status);my ($nxplreturn);foreach my $listpid (keys (%$children)){Logger::debug3
 ((
"\x68\x61\x6e\x64\x6c\x65\x53\x49\x47\x43\x48\x4c\x44\x20\x63\x68\x65\x63\x6b\x69\x6e\x67\x20\x63\x68\x69\x6c\x64\x3a\x20"
.$listpid),(0x00f6+ 5288-0x159e));($nxplreturn=nxChildProcessCheck ($listpid));
unless ($nxplreturn){removechild ($listpid);my ($callback);if ((
$$NXProcess::finishedChildren{$listpid}==(0x177f+ 884-0x1af3))){($callback=
$$NXProcess::childrenExitCallback{$listpid});}else{($callback=
$$NXProcess::childrenErrorCallback{$listpid});}&{$callback;}($listpid,
$$NXProcess::finishedChildren{$listpid});}}handleWatchDogSIG ();
handleWatchdogAsSuperuserSIGCHLD ();}sub getExitValue{(my $pid=shift (@_));(my $exitValue
=$$NXProcess::finishedChildren{$pid});if ((not (defined ($exitValue)))){if ((not
 (isChildProcess ($pid)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid).
"\x2e\x20\x54\x68\x69\x73\x20\x69\x73\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));return ((0x0a01+ 6867-0x24d4));}else{Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x65\x78\x69\x74\x20\x63\x6f\x64\x65\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20"
.$pid).
"\x2e\x20\x50\x72\x6f\x63\x65\x73\x73\x20\x73\x74\x69\x6c\x6c\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
));return ((0x1ca6+ 1153-0x2127));}}return ($exitValue);}sub isChildProcess{(my $pid
=shift (@_));if (exists ($$NXProcess::children{$pid})){return (
(0x09ac+ 7399-0x2692));}else{return ((0x1dbc+ 1923-0x253f));}}sub 
isOnWatchdogProcess{(my $pid=shift (@_));if (exists ($$NXProcess::watchDogList{
$pid})){return ((0x00a6+ 1589-0x06da));}else{return ((0x0fad+ 5137-0x23be));}}
sub isChildFinished{(my $pid=shift (@_));if (exists (
$$NXProcess::finishedChildren{$pid})){return ((0x0921+ 6408-0x2228));}else{
return ((0x0eb5+ 2698-0x193f));}}sub isFinishedWatchDog{(my $pid=shift (@_));if 
(exists ($$NXProcess::finishedWatchDogList{$pid})){return ((0x2185+ 1277-0x2681)
);}else{return ((0x229f+ 338-0x23f1));}}sub processTerminatedBySignal{(my $pid=
shift (@_));if (($$NXProcess::childFinishedWithSignal{$pid}==
(0x0db6+ 3913-0x1cfe))){return ((0x10ea+ 816-0x1419));}else{return (
(0x0538+ 7504-0x2288));}}sub waitProcess{(my $pid=shift (@_));(my $timeout=shift
 (@_));my ($exitValue);my ($waitpidOption);my ($waitpidResult);my ($return);if (
($timeout gt (0x0367+ 8901-0x262c))){($waitpidOption=$NXBits::WAIT_UNTRACED);
Logger::debug (((((
"\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x3a\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$pid)."\x27\x20\x75\x73\x69\x6e\x67\x20").$timeout).
"\x73\x20\x61\x73\x20\x74\x69\x6d\x65\x6f\x75\x74"));}else{($waitpidOption=
$NXBits::WAIT_NOHANG);Logger::debug (((
"\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x3a\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$pid)."\x27"));}unless ((isChildProcess ($pid)or isOnWatchdogProcess ($pid))){
Logger::debug (((
"\x4e\x58\x50\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20"
.$pid).
"\x20\x6e\x6f\x74\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x65\x64\x2c\x20\x61\x64\x64\x69\x6e\x67\x20\x77\x61\x74\x63\x68\x64\x6f\x67\x2e"
));addWatchdog ($pid);}($waitpidResult=nxwaitpid ($pid,$waitpidOption,$timeout))
;if (($waitpidResult==$pid)){($exitValue=getStatusExited ());}elsif ((
$waitpidResult==(0x0e01+ 4437-0x1f56))){Logger::debug (((
"\x72\x65\x61\x63\x68\x65\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x6f\x66\x20".
$timeout).((
"\x73\x20\x77\x68\x69\x6c\x65\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27")));($exitValue=getStatusRunning ());}elsif (($waitpidResult==(-
(0x0d48+ 965-0x110c)))){Logger::debug (((
"\x6e\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20\x27"
.$pid)."\x27\x20\x74\x6f\x20\x77\x61\x69\x74"));($exitValue=
getErrorNoProcessToWait ());}return ($exitValue);}sub getErrorNoProcessToWait{
return ($NXProcess::errorNoProcessToWait);}sub getStatusRunning{return (
$NXProcess::statusRunning);}sub getStatusExited{return ($NXProcess::statusExited
);}sub getSignalKill{return ($NXProcess::signalKill);}sub getSignalTerm{return (
$NXProcess::signalTerm);}sub getSignalSegv{return ($NXProcess::signalSegv);}sub 
getProcessTree{return ($NXProcess::processTree);}sub getNoProcessTree{return (
$NXProcess::noProcessTree);}sub registerChildName{(my $processName=shift (@_));(my $processPid
=shift (@_));(my ($sec,$microsec)=
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf (
"\x25\x30\x36\x64",$microsec));($milisec=substr ($milisec,(0x0e8d+ 5281-0x232e),
(0x08ba+ 5554-0x1e69)));Logger::debug2 (((((((((
"\x50\x72\x6f\x63\x65\x73\x73\x20\x27".$processName).
"\x27\x20\x73\x74\x61\x72\x74\x65\x64\x20\x77\x69\x74\x68\x20\x70\x69\x64\x3a\x20\x27"
).$processPid).
"\x27\x20\x61\x74\x20\x74\x69\x6d\x65\x73\x74\x61\x6d\x70\x20\x27").$sec)."\x2c"
).$milisec)."\x27"));($$NXProcess::childrenData{$processPid}={});(
$$NXProcess::childrenData{$processPid}{"\x6e\x61\x6d\x65"}=$processName);(
$$NXProcess::childrenData{$processPid}{
"\x73\x74\x61\x72\x74\x53\x65\x63\x6f\x6e\x64\x73"}=$sec);(
$$NXProcess::childrenData{$processPid}{
"\x73\x74\x61\x72\x74\x4d\x69\x6c\x69\x73\x65\x63\x6f\x6e\x64\x73"}=$milisec);}
sub getChildNameAndLifetime{(my $pid=shift (@_));(my $childData=
$$NXProcess::childrenData{$pid});if (defined ($childData)){(my $name=$$childData
{"\x6e\x61\x6d\x65"});(my ($sec,$microsec)=
Common::NXTime::getSecondsAndMicrosecondsSinceEpoch ());(my $milisec=sprintf (
"\x25\x30\x36\x64",$microsec));($milisec=substr ($milisec,(0x0020+ 4170-0x106a),
(0x1d84+ 1312-0x22a1)));(my $startSeconds=$$NXProcess::childrenData{$pid}{
"\x73\x74\x61\x72\x74\x53\x65\x63\x6f\x6e\x64\x73"});(my $startMiliseconds=
$$NXProcess::childrenData{$pid}{
"\x73\x74\x61\x72\x74\x4d\x69\x6c\x69\x73\x65\x63\x6f\x6e\x64\x73"});(my $liveTimeSeconds
=($sec-$startSeconds));(my $liveTimeMiliseconds=($milisec-$startMiliseconds));if
 (($liveTimeMiliseconds<(0x2289+ 1006-0x2677))){($liveTimeMiliseconds=(
$liveTimeMiliseconds+(0x1785+ 1623-0x19f4)));($liveTimeSeconds=($liveTimeSeconds
-(0x0a0d+ 5545-0x1fb5)));}(my $liveTime=(($liveTimeSeconds."\x2c").sprintf (
"\x25\x30\x33\x64",$liveTimeMiliseconds)));return ($name,$liveTime);}return (
(""),(0x01a4+ 513-0x03a5));}sub waitToTerminateOrKillIfStayAlive{(my $processPid
=shift (@_));(my $sleepTime=shift (@_));if (((not (defined ($processPid)))or (
$processPid<(0x0eba+ 5685-0x24ef)))){Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x77\x61\x69\x74\x20\x74\x6f\x20\x74\x65\x72\x6d\x69\x6e\x61\x74\x65\x20\x6f\x72\x20\x6b\x69\x6c\x6c\x20\x69\x66\x20\x73\x74\x61\x79\x20\x61\x6c\x69\x76\x65\x20\x77\x69\x74\x68\x6f\x75\x74\x20\x50\x49\x44\x2e"
);return;}if (((not (defined ($sleepTime)))or ($sleepTime<(0x0841+ 7621-0x2605))
)){($sleepTime=(0x1494+ 2123-0x1cde));}if (isProcessRunning ($processPid)){
nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime);if (isProcessRunning (
$processPid)){if (sigkill ($processPid)){Logger::debug (((
"\x53\x49\x47\x4b\x49\x4c\x4c\x20\x73\x65\x6e\x74\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid)."\x2e"));}}}else{Logger::debug (((
"\x43\x75\x73\x74\x6f\x6d\x20\x68\x61\x6e\x64\x6c\x65\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20\x27"
.$processPid).
"\x27\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub waitToTerminateOrKillByScriptIfStayAlive{(my $processPid=shift (@_));(my $sleepTime
=shift (@_));if (((not (defined ($processPid)))or ($processPid<
(0x1f74+ 814-0x22a2)))){Logger::warning (
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x69\x64\x20\x6e\x6f\x74\x20\x70\x72\x6f\x76\x69\x64\x65\x64\x2e"
);return;}if (((not (defined ($sleepTime)))or ($sleepTime<(0x0673+ 4068-0x1656))
)){($sleepTime=(0x0605+ 229-0x06e9));}if (isProcessRunning ($processPid)){(my $waitpid
=nxwaitpid ($processPid,$NXBits::WAIT_UNTRACED,$sleepTime));if (($waitpid!=
$processPid)){Logger::warning (((((
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid).
"\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x66\x69\x6e\x69\x73\x68\x20\x77\x69\x74\x68\x69\x6e\x20"
).$sleepTime).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e\x20\x4b\x69\x6c\x6c\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x62\x79\x20\x72\x65\x73\x74\x72\x69\x63\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x2e"
));signalProcessByRestrictedScript ($processPid,getSignalKill ());}}else{
Logger::debug (((
"\x77\x61\x69\x74\x54\x6f\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x4f\x72\x4b\x69\x6c\x6c\x42\x79\x53\x63\x72\x69\x70\x74\x49\x66\x53\x74\x61\x79\x41\x6c\x69\x76\x65\x3a\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$processPid).
"\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x6f\x70\x70\x65\x64\x2e"
));}}sub addWatchdogAsSuperuserOnWindows{Logger::warning (
"\x46\x75\x6e\x63\x74\x69\x6f\x6e\x20\x61\x64\x64\x57\x61\x74\x63\x68\x64\x6f\x67\x41\x73\x53\x75\x70\x65\x72\x75\x73\x65\x72\x4f\x6e\x57\x69\x6e\x64\x6f\x77\x73\x20\x63\x61\x6e\x20\x6f\x6e\x6c\x79\x20\x62\x65\x20\x72\x75\x6e\x20\x6f\x6e\x20\x57\x69\x6e\x64\x6f\x77\x73\x20\x73\x79\x73\x74\x65\x6d\x2e"
);return ((-(0x1699+ 3753-0x2541)));}sub addProcessToWatchdogAsSuperuserList{(my $pid
=shift (@_));(my $handle=shift (@_));($$NXProcess::watchDogAsSuperuser{$pid}=
$handle);delete ($$NXProcess::finishedWatchDogList{$pid});}sub 
handleWatchdogAsSuperuserSIGCHLD{foreach my $pid (keys (
%$NXProcess::watchDogAsSuperuser)){(my $handle=$$NXProcess::watchDogAsSuperuser{
$pid});Logger::debug3 (((((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x6e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27"
.$pid)."\x27\x20\x77\x69\x74\x68\x20\x68\x61\x6e\x64\x6c\x65\x20\x27").$handle).
"\x27\x2e"));if ((not (libnxh::NXProcessRunning ($pid)))){Logger::debug (((
"\x4e\x6f\x74\x20\x63\x68\x69\x6c\x64\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27".
$pid)."\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"));(my $callback
=$$NXProcess::childrenExitCallback{$pid});Logger::debug (((((
"\x45\x78\x65\x63\x75\x74\x69\x6e\x67\x20\x63\x61\x6c\x6c\x62\x61\x63\x6b\x20\x27"
.$callback)."\x27\x20\x66\x6f\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x27").$pid
)."\x27\x2e"));delete ($$NXProcess::watchDogAsSuperuser{$pid});Logger::debug (((
"\x52\x65\x6d\x6f\x76\x69\x6e\x67\x20\x68\x61\x6e\x64\x6c\x65\x20\x27".$handle).
"\x27\x20\x74\x6f\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6c\x69\x73\x74\x2e"));(my $return
=libnxh::NXRemoveProcess ($handle));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x3a\x3a\x4e\x58\x52\x65\x6d\x6f\x76\x65\x50\x72\x6f\x63\x65\x73\x73\x28"
.$handle)."\x29\x20\x72\x65\x74\x75\x72\x6e\x65\x64\x20\x27").$return).
"\x27\x2e"));if (($return==(-(0x104d+ 1979-0x1807)))){
Common::NXCore::reportErrorFromNXPL (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x6d\x6f\x76\x65\x20\x68\x61\x6e\x64\x6c\x65\x20\x27"
.$handle).
"\x27\x20\x66\x72\x6f\x6d\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x6c\x69\x73\x74\x2e"
));}($$NXProcess::finishedWatchDogList{$pid}=(0x0769+ 817-0x0a99));if ((
$callback ne (""))){&{$callback;}($pid,(0x08d6+ 4130-0x18f8));}}}}sub 
setChildExitCode{(my $pid=shift (@_));(my $code=shift (@_));(
$$NXProcess::finishedChildren{$pid}=$code);}sub getChildExitCode{(my $pid=shift 
(@_));if ((not (processTerminatedBySignal ($pid)))){return (
$$NXProcess::finishedChildren{$pid});}return (undef);}sub setChildExitSignal{(my $pid
=shift (@_));(my $sig=shift (@_));($$NXProcess::finishedChildren{$pid}=$sig);(
$$NXProcess::childFinishedWithSignal{$pid}=(0x05a8+ 5127-0x19ae));}sub 
getChildExitSignal{(my $pid=shift (@_));if (processTerminatedBySignal ($pid)){
return ($$NXProcess::finishedChildren{$pid});}return (undef);}sub 
getChildrenOfProcess{(my $pid=shift (@_));(my $commandPath=
Common::NXShellCommands::getPath ("\x70\x73"));if (($commandPath eq 
$Common::NXShellCommands::pathNotFound)){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x69\x73\x74\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6f\x66\x20\x27"
.$pid).
"\x27\x2e\x20\x50\x72\x6f\x67\x72\x61\x6d\x20\x27\x70\x73\x27\x20\x69\x73\x20\x6e\x6f\x74\x20\x70\x72\x65\x73\x65\x6e\x74\x20\x69\x6e\x20\x61\x20\x6b\x6e\x6f\x77\x6e\x20\x70\x61\x74\x68\x2e"
));return (());}(my (@command)=());(my (@options)=());push (@command,
$commandPath);push (@command,"\x2d\x2d\x70\x70\x69\x64",$pid);push (@command,
"\x2d\x6f");push (@command,"\x70\x69\x64\x3d");(my ($stderr,$stdout,$exitValue)=
main::nxRunCommand ((\@command),(\@options)));if (($exitValue!=
(0x07b5+ 6448-0x20e5))){Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x69\x73\x74\x20\x63\x68\x69\x6c\x64\x72\x65\x6e\x20\x6f\x66\x20\x27"
.$pid)."\x27\x2e"));return (());}($stdout=~ s/^\s+|\s+$//g );(my (@pids)=split ( /\s+/ ,
$stdout,(0x2245+  50-0x2277)));return (@pids);}"\x3f\x3f\x3f";
