############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
package NXLogrotate;no warnings;($__timeoutForFileReleasedCheck=
(0x20b7+ 908-0x2434));($__sleepTimeBetweenFileReleaseChecks=0.2);(
$__checkLogrotateDelay=(0x05fb+ 4241-0x1308));($__lastCheckLogrotate=
(0x0aeb+ 1339-0x1026));($__nxhtdErrorLogPath=(""));($__forcedRotate=
(0x15df+ 3370-0x2309));($__forcedRotateDateTime=(""));((
%__ref_forcedRotateParameters)=());((%threadHandles)=());sub 
__rotateTillOriginalFile{(my $type=shift (@_));(my $rotatedName=shift (@_));(my $rotationDir
=NXLogrotateDB::getDestination ($type));(my $maxRotation=
NXLogrotateDB::getRotate ($type));(my $prevRotatedFile=((($rotationDir.
$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2e")).($maxRotation+
(0x1603+ 3436-0x236e))));if (NXLogrotateDB::isCompressSet ($type)){(
$prevRotatedFile=($prevRotatedFile."\x2e\x67\x7a"));}for ((my $i=$maxRotation);(
$i>(0x2063+ 1636-0x26c7));(--$i)){(my $curRotatedFile=((($rotationDir.
$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2e")).$i));if (
NXLogrotateDB::isCompressSet ($type)){($curRotatedFile=($curRotatedFile.
"\x2e\x67\x7a"));}if (Common::NXFile::fileExists ($curRotatedFile)){($result=
Common::NXFile::renameFile ($curRotatedFile,$prevRotatedFile));if (($result==
(0x0757+ 4357-0x185c))){NXMsg::error (
"\x65\x43\x61\x6e\x6e\x6f\x74\x52\x65\x6e\x61\x6d\x65\x46\x69\x6c\x65",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$curRotatedFile,$prevRotatedFile)
;return ((0x1537+ 342-0x168d));}}($prevRotatedFile=$curRotatedFile);}return (
(0x1ac9+ 570-0x1d02));}sub __copyTruncate{(my $type=shift (@_));(my $path=shift 
(@_));(my $rotatedName=shift (@_));(my $destFilePath=
__getRotatedLogFilePathByLogType ($type,$rotatedName));(my $result=__copyLogFile
 ($path,$destFilePath));if (($result==(0x0d09+ 5788-0x23a5))){return (
(0x1f83+ 408-0x211b));}return (__truncateFile ($path));}sub __removeExpiredLogs{
(my $type=shift (@_));(my $rotatedName=shift (@_));(my $rotationDir=
NXLogrotateDB::getDestination ($type));(my $maxRotation=NXLogrotateDB::getRotate
 ($type));(my $fileToRemove=((($rotationDir.$GLOBAL::DIRECTORY_SLASH).(
$rotatedName."\x2e")).($maxRotation+(0x02c1+ 9259-0x26eb))));if (
NXLogrotateDB::isCompressSet ($type)){($fileToRemove=($fileToRemove.
"\x2e\x67\x7a"));}if (Common::NXFile::fileExists ($fileToRemove)){return (
Common::NXFile::removeFile ($fileToRemove));}return ((0x0526+ 7758-0x2373));}sub
 forcedRotate{(my $ref_parameters=shift (@_));(my $result=
__handleForcedRotateParameters ($ref_parameters));if (($result==
(0x0121+ 8989-0x243e))){return ((0x042c+ 3306-0x1116));}if (($$ref_parameters{
"\x74\x79\x70\x65"}and (not (isLogTypeSupported ($$ref_parameters{
"\x74\x79\x70\x65"}))))){(my (@supportedTypes)=getAllSupportedLogrotateLogTypes 
());NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x54\x79\x70\x65\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$$ref_parameters{
"\x74\x79\x70\x65"},join ($",@supportedTypes));return ((0x04a4+ 7564-0x2230));}(my $dateTime
=Common::NXTime::getDateTimeForFileName ());__setForcedRotateDateTime ($dateTime
);__setForcedRotate ();return (rotate ($$ref_parameters{"\x74\x79\x70\x65"}));}
sub rotate{(my $type=(shift (@_)||("")));Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x65\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x2e"
);NXMsg::send_response (
"\x69\x43\x4d\x44\x53\x74\x61\x72\x74\x69\x6e\x67\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65");if (($type ne (""))){
__rotateByLogType ($type);}else{rotateAllLogFiles ();}Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x68\x61\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x2e"
);}sub rotateAllLogFiles{main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");(my (
@availableTypes)=());if (__isForcedRotate ()){(@availableTypes=
getAllSupportedLogrotateLogTypes ());}else{(@availableTypes=
NXLogrotateDB::getLogTypes ());}foreach my $availableType (@availableTypes){if (
__shouldSkipMultiTypeLogrotateForType ($availableType)){next;}__rotateByLogType 
($availableType);}}sub __rotateByLogType{(my $type=shift (@_));Logger::debug (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x65\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x2e"));if (__isNotForcedRotate ()){main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");if (
NXLogrotateDB::isNotLogrotateExist ($type)){Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").
"\x4c\x6f\x67\x20\x74\x79\x70\x65\x20\x69\x73\x20\x6e\x6f\x74\x20\x65\x6e\x61\x62\x6c\x65\x64\x20\x66\x6f\x72\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x2e"
));NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x6f\x65\x73\x4e\x6f\x74\x45\x78\x69\x73\x74"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42",$type);NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);return (
(0x014c+ 4788-0x1400));}}($result=__rotateFilesByLogType ($type));if (($result==
(0x1284+ 594-0x14d6))){Logger::error (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"));NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);}else{Logger::debug (((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type).
"\x27\x20\x68\x61\x73\x20\x66\x69\x6e\x69\x73\x68\x65\x64\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x2e"
));NXMsg::send_response (
"\x69\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$type);}return ($result);}sub 
__getUserLogFilePathsByType{(my $type=shift (@_));(my $ref_filePaths=shift (@_))
;(my (@filePaths)=());(my (%users)=
NXUsersManager::userListIncludingInternalDMUsers ());foreach my $user (keys (
%users)){if (NXUsersManager::isDMUser ($user)){($user=
NXUsersManager::getRealDMUsername ($user));}(my $fileName=__getFilenameByLogType
 ($type));(my $path=((Common::NXPaths::getNxDirectoryInUserHomeDirectory ($user)
.$GLOBAL::DIRECTORY_SLASH).$fileName));(my $rotatedName=($fileName.("\x2d".$user
)));($$ref_filePaths{$rotatedName}=$path);}}sub 
__getSpecialUserLogFilePathByType{(my $type=shift (@_));(my $ref_filePaths=shift
 (@_));(my $fileName=__getFilenameByLogType ($type));(my $path=((
Common::NXPaths::getSpecialUsersLogFolderPath ().$GLOBAL::DIRECTORY_SLASH).
$fileName));($$ref_filePaths{$fileName}=$path);}sub __getFilePathsByLogType{(my $type
=shift (@_));(my (%filePaths)=());if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){if (($GLOBAL::CommonLogDirectory ne 
(""))){(my $fileName=__getFilenameByLogType ($type));(my $rotateFileName=(
$fileName."\x2d\x63\x6f\x6d\x6d\x6f\x6e"));($filePaths{$rotateFileName}=((
$GLOBAL::CommonLogDirectory.$GLOBAL::DIRECTORY_SLASH).$fileName));}else{
__getUserLogFilePathsByType ($type,(\%filePaths));
__getSpecialUserLogFilePathByType ($type,(\%filePaths));}}else{(my $fileName=
__getFilenameByLogType ($type));($filePaths{$fileName}=__getFilePathByLogType (
$type));}return (%filePaths);}sub __rotateFilesByLogType{(my $type=shift (@_));(my $ref_filePaths
=shift (@_));(my $silent=(shift (@_)||(0x13e5+ 1789-0x1ae2)));(my (%filePaths)=
());if (__isNotForcedRotate ()){((%filePaths)=%$ref_filePaths);}else{((
%filePaths)=__getFilePathsByLogType ($type));}(my $filesCount=
(0x005f+ 519-0x0266));(my $noExistPath=(""));(my $result=(0x0430+ 442-0x05e9));
foreach my $rotatedName (keys (%filePaths)){(my $path=$filePaths{$rotatedName});
if ((not (Common::NXFile::fileExists ($path)))){($noExistPath=$path);next;}(++
$filesCount);($result=__rotateWithCopytruncate ($type,$path,$rotatedName));if ((
$result!=(0x0be2+ 3363-0x1905))){($result=__postRotate ($type,$rotatedName,
$silent));}}if (($filesCount==(0x1b8b+ 2775-0x2662))){if ((scalar (@filePaths)>
(0x0833+ 7178-0x243c))){Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").
"\x4e\x6f\x20\x6c\x6f\x67\x20\x66\x69\x6c\x65\x73\x20\x66\x6f\x75\x6e\x64\x2e"))
;}else{Logger::error ((((
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x4c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x70\x72\x6f\x63\x65\x64\x75\x72\x65\x20\x66\x6f\x72\x20\x27"
.$type)."\x27\x20\x68\x61\x73\x20\x66\x61\x69\x6c\x65\x64\x2e\x20").((
"\x4c\x6f\x67\x20\x66\x69\x6c\x65\x20\x27".$path).
"\x27\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e")));if ((
$silent==(0x0820+ 758-0x0b16))){Common::NXMsg::error (
"\x65\x46\x69\x6c\x65\x4e\x6f\x74\x45\x78\x69\x73\x74",$noExistPath);}}if ((
$silent==(0x1a3b+ 2796-0x2527))){NXMsg::error (
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$noExistPath);}return (
(0x0434+ 6308-0x1cd8));}return ($result);}sub __postRotate{(my $type=shift (@_))
;(my $rotatedName=shift (@_));(my $silent=shift (@_));if (((__isForcedRotate ()
and __isForcedRotateCompress ())or ((not (__isForcedRotate ()))and 
NXLogrotateDB::isCompressSet ($type)))){(my $rotatedFile=
__getRotatedLogFilePathByLogType ($type,$rotatedName));($result=__compressFile (
$rotatedFile,$silent));if (($result==(0x0e62+ 3891-0x1d95))){return (
(0x1574+ 1411-0x1af7));}Common::NXFile::removeFile ($rotatedFile);}return (
(0x047f+ 2189-0x0d0b));}sub __rotateWithCopytruncate{(my $type=shift (@_));(my $path
=shift (@_));(my $rotatedName=shift (@_));if (__isNotForcedRotate ()){(my $result
=__rotateTillOriginalFile ($type,$rotatedName));__removeExpiredLogs ($type,
$rotatedName);if (($result==(0x0f97+ 4069-0x1f7c))){return ((0x0dc8+ 964-0x118c)
);}}return (__copyTruncate ($type,$path,$rotatedName));}sub 
__getRotatedLogFilePathByLogType{(my $type=shift (@_));(my $rotatedName=shift (
@_));if (__isNotForcedRotate ()){(my $destination=NXLogrotateDB::getDestination 
($type));return ((($destination.$GLOBAL::DIRECTORY_SLASH).($rotatedName.
"\x2e\x31")));}else{(my $destination=__getForcedRotateDestination ());return (((
($destination.$GLOBAL::DIRECTORY_SLASH).($rotatedName."\x2d")).
__getForcedRotateDateTime ()));}}sub __compressFile{(my $logFilePath=shift (@_))
;(my $silent=shift (@_));(my $compressedFile=($logFilePath."\x2e\x67\x7a"));(my $result
=Common::NXFile::compressFile ($logFilePath,$compressedFile));if (($result!=
(0x0897+ 6069-0x204b))){if (($silent==(0x04fa+ 1113-0x0953))){NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6d\x70\x72\x65\x73\x73\x46\x69\x6c\x65"
,"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$logFilePath);}return (
(0x0632+ 6984-0x217a));}else{if (($silent==(0x19e6+  83-0x1a39))){
NXMsg::send_response (
"\x69\x43\x4d\x44\x43\x6f\x6d\x70\x72\x65\x73\x73\x65\x64\x46\x69\x6c\x65",
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",$compressedFile);}
__correctRotatedFileOwnershipAndPermissions ($compressedFile);return (
(0x0914+ 2463-0x12b2));}}sub isTimeForCheckLogrotate{(my $currentTime=
Common::NXTime::getSecondsSinceEpoch ());(my $delay=$__checkLogrotateDelay);if (
(($__lastCheckLogrotate+$delay)<$currentTime)){return ((0x0090+ 9009-0x23c0));}
return ((0x129d+ 4919-0x25d4));}sub checkLogrotateAndHandleIfNeeded{
Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x53\x74\x61\x72\x74\x69\x6e\x67\x20\x73\x63\x68\x65\x64\x75\x6c\x65\x64\x20\x6c\x6f\x67\x20\x72\x6f\x74\x61\x74\x69\x6f\x6e\x20\x63\x68\x65\x63\x6b\x20\x66\x6f\x72\x20\x61\x6c\x6c\x20\x66\x69\x6c\x65\x73\x2e"
);($__lastCheckLogrotate=Common::NXTime::getSecondsSinceEpoch ());(my (
@typesToRotate)=());main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42");NXLogrotateDB::reload ()
;(my (@logTypes)=NXLogrotateDB::getLogTypes ());foreach my $type (@logTypes){(my $size
=NXLogrotateDB::getSizeInBytes ($type));(my $minsize=
NXLogrotateDB::getMinsizeInBytes ($type));(my $isTimeToRotate=
NXLogrotateDB::isTimeToRotate ($type));(my (%filePaths)=__getFilePathsByLogType 
($type));foreach my $fileName (keys (%filePaths)){(my $filePath=$filePaths{
$fileName});(my $fileSize=Common::NXCore::NXFileSize ($filePath));if (($size and
 ($size<=$fileSize))){return (__runLogrotateCommand ());}if ($isTimeToRotate){if
 (((not ($minsize))or ($minsize<$fileSize))){return (__runLogrotateCommand ());}
}}}}sub __runLogrotateCommand{(my (@command)=($GLOBAL::CommandNXexec,
$GLOBAL::SCRIPT_NXLOGROTATE));(my (@options)=
"\x72\x75\x6e\x20\x69\x6e\x20\x62\x67");main::nxRunCommand ((\@command),(
\@options));Logger::debug (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x3a\x20\x41\x75\x74\x6f\x6d\x61\x74\x69\x63\x20\x6c\x6f\x67\x72\x6f\x74\x61\x74\x65\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x75\x6e\x2e"
);}sub automaticRotate{(my (%typesToRotate)=());main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42");NXLogrotateDB::reload ()
;(my (@logTypes)=NXLogrotateDB::getLogTypes ());foreach my $type (@logTypes){(my $size
=NXLogrotateDB::getSizeInBytes ($type));(my $minsize=
NXLogrotateDB::getMinsizeInBytes ($type));(my $isTimeToRotate=
NXLogrotateDB::isTimeToRotate ($type));(my (%filePaths)=__getFilePathsByLogType 
($type));(my (%pathsToRotate)=());if (__shouldSkipMultiTypeLogrotateForType (
$type)){next;}foreach my $fileName (keys (%filePaths)){(my $filePath=$filePaths{
$fileName});(my $fileSize=Common::NXCore::NXFileSize ($filePath));if (($size and
 ($size<=$fileSize))){($pathsToRotate{$fileName}=$filePath);($typesToRotate{
$type}=(\%pathsToRotate));next;}if ($isTimeToRotate){if (((not ($minsize))or (
$minsize<$fileSize))){($pathsToRotate{$fileName}=$filePath);($typesToRotate{
$type}=(\%pathsToRotate));next;}}}}(my $silent=(0x121d+ 1328-0x174c));foreach my $type
 (keys (%typesToRotate)){__rotateFilesByLogType ($type,$typesToRotate{$type},
$silent);NXLogrotateDB::updateLastRotateTime ($type);}}sub 
__getFilePathByLogType{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return (
Common::NXPaths::getNXServerLogPath ());}elsif (($type eq 
Logger::getLogrotateLogTypeNxdLog ())){return (NXPaths::getNxdLog ());}elsif ((
$type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
NXPaths::getNxwebclientLog ());}elsif (($type eq 
Logger::getLogrotateLogTypeNxhtdErrorLog ())){if (($__nxhtdErrorLogPath eq (""))
){($__nxhtdErrorLogPath=NXTools::getNxhtdErrorLogPath ());}return (
$__nxhtdErrorLogPath);}elsif (($type eq Logger::getLogrotateLogTypeNxserviceLog 
())){return (NXPaths::getNxserviceLog ());}else{return ((""));}}sub 
__getFilenameByLogType{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return (
"\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67");}elsif (($type eq 
Logger::getLogrotateLogTypeNxdLog ())){return ("\x6e\x78\x64\x2e\x6c\x6f\x67");}
elsif (($type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
"\x6e\x78\x77\x65\x62\x72\x75\x6e\x6e\x65\x72\x2e\x6c\x6f\x67");}elsif (($type 
eq Logger::getLogrotateLogTypeNxhtdErrorLog ())){return (
"\x6e\x78\x68\x74\x64\x2e\x6c\x6f\x67");}elsif (($type eq 
Logger::getLogrotateLogTypeNxserviceLog ())){return (
"\x6e\x78\x73\x65\x72\x76\x69\x63\x65\x2e\x6c\x6f\x67");}else{return ((""));}}
sub isLogTypeSupported{(my $type=shift (@_));(my (@supportedTypes)=
getAllSupportedLogrotateLogTypes ());foreach my $supportedType (@supportedTypes)
{if (($supportedType eq $type)){return ((0x1552+ 1082-0x198b));}}return (
(0x1766+ 3601-0x2577));}sub getAllSupportedLogrotateLogTypes{(my (@types)=());
push (@types,Logger::getLogrotateLogTypeNxserverLog ());push (@types,
Logger::getLogrotateLogTypeNxdLog ());if (NXLicense::isHttpdSupportFeature ()){
push (@types,Logger::getLogrotateLogTypeNwebclientLog ());push (@types,
Logger::getLogrotateLogTypeNxhtdErrorLog ());}return (@types);}sub 
__isTypeNxserverLog{(my $type=shift (@_));if (($type eq 
Logger::getLogrotateLogTypeNxserverLog ())){return ((0x0895+ 7211-0x24bf));}
return ((0x09ac+ 1646-0x101a));}sub __isTypeNxwebclientLog{(my $type=shift (@_))
;if (($type eq Logger::getLogrotateLogTypeNwebclientLog ())){return (
(0x0477+ 8600-0x260e));}return ((0x0075+ 4293-0x113a));}sub __truncateFile{(my $filePath
=shift (@_));(my $handle=main::nxopen ($filePath,($NXBits::O_WRONLY+
$NXBits::O_TRUNC)));if (defined ($handle)){main::nxclose ($handle);return (
(0x1e41+ 2106-0x267a));}return ((0x194d+ 1481-0x1f16));}sub __copyLogFile{(my $filePath
=shift (@_));(my $destFilePath=shift (@_));(my ($return,$error)=
Common::NXCore::copyFile ($filePath,$destFilePath));if (($error ne (""))){return
 ((0x09a8+ 4557-0x1b75));}__correctRotatedFileOwnershipAndPermissions (
$destFilePath);return ((0x0abd+ 4334-0x1baa));}sub 
__correctRotatedFileOwnershipAndPermissions{(my $file=shift (@_));
Common::NXFile::setPermissionsReadWriteForNX ($file);if (
main::effectiveUserIsAdministrator ()){
Common::NXFile::setOwnershipForUserAndGroupNX ($file);}return (
(0x1524+ 3370-0x224d));}sub __setForcedRotateDateTime{($__forcedRotateDateTime=
shift (@_));}sub __getForcedRotateDateTime{return ($__forcedRotateDateTime);}sub
 __setForcedRotate{($__forcedRotate=(0x0303+ 3113-0x0f2b));}sub __isForcedRotate
{return ($__forcedRotate);}sub __getForcedRotateDestination{return (
$$__ref_forcedRotateParameters{"\x64\x65\x73\x74\x69\x6e\x61\x74\x69\x6f\x6e"});
}sub __isForcedRotateCompress{if (($$__ref_forcedRotateParameters{
"\x63\x6f\x6d\x70\x72\x65\x73\x73"}eq "\x6e\x6f")){return ((0x02bb+ 1378-0x081d)
);}else{return ((0x1826+ 2832-0x2335));}}sub __isNotForcedRotate{return ((!
__isForcedRotate ()));}sub __handleForcedRotateParameters{(my $ref_parameters=
shift (@_));($__ref_forcedRotateParameters=$ref_parameters);main::nxrequire (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x44\x42","\x69\x6e\x69\x74");(my $procedure
="\x66\x6f\x72\x63\x65\x64\x52\x6f\x74\x61\x74\x65");return (
NXLogrotateDB::handleDestinationAndCompressParameters ($ref_parameters,
$procedure));}sub __shouldSkipMultiTypeLogrotateForType{(my $type=shift (@_));
return ((0x123f+ 2177-0x1ac0));}NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x53\x74\x61\x72\x74\x69\x6e\x67\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65"
,(0x19ff+ 4046-0x2649));NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x69\x6e\x69\x73\x68\x65\x64"
,(0x163b+ 1631-0x1916));NXMsg::register_response (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x69\x43\x4d\x44\x43\x6f\x6d\x70\x72\x65\x73\x73\x65\x64\x46\x69\x6c\x65",
(0x09fc+ 2270-0x0f56));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x46\x61\x69\x6c\x65\x64",
(0x06fd+ 3163-0x1164));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x46\x69\x6c\x65\x49\x73\x42\x65\x69\x6e\x67\x55\x73\x65\x64",
(0x1cea+ 1602-0x2138));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6d\x70\x72\x65\x73\x73\x46\x69\x6c\x65"
,(0x1c8c+ 1215-0x1f57));NXMsg::register_error (
"\x4e\x58\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65",
"\x65\x43\x4d\x44\x4c\x6f\x67\x72\x6f\x74\x61\x74\x65\x54\x79\x70\x65\x4e\x6f\x74\x53\x75\x70\x70\x6f\x72\x74\x65\x64"
,(0x160a+ 1540-0x1a1a));"\x3f\x3f\x3f";
