############################################################################
#                                                                          #
#  Copyright (c) 2001, 2023 NoMachine, http://www.nomachine.com.           #
#                                                                          #
#  NXSERVER, NX protocol compression and NX extensions to this software    #
#  are copyright of NoMachine. Redistribution and use of the present       #
#  software is allowed according to terms specified in the file LICENSE    #
#  which comes in the source distribution.                                 #
#                                                                          #
#  Check http://www.nomachine.com/licensing.html for applicability.        #
#                                                                          #
#  NX and NoMachine are trademarks of NoMachine S.a.r.l.                   #
#                                                                          #
#  All rights reserved.                                                    #
#                                                                          #
############################################################################
sub NXRedis::BEGIN{package NXRedis;no warnings;require NXMsg;do{
"\x4e\x58\x4d\x73\x67"->import};}package NXRedis;no warnings;$selector;
$readRedis;$writeRedis;$daemonRedis;$clientRedis;($retry=(0x0e18+ 1945-0x15b1));
($connected=(0x0da3+ 5270-0x2239));($serverInit=(0x0093+ 8720-0x22a3));(
$multiCommand=(0x02b5+ 6351-0x1b84));($resendSuccess=(0x1279+ 3719-0x2100));(
$waitingConnect=(0x0435+ 3233-0x10d6));($lockFileHandle=(-(0x0c8d+ 914-0x101e)))
;($redisServerPid=(-(0x06bc+ 2262-0x0f91)));($waitingForAcquireTimeout=
(0x0196+ 2354-0x0a14));($waitingForReleaseCounter=(0x149c+ 2626-0x1ede));(
$waitingForNewDaemonCounter=(0x0cfa+ 1614-0x1348));($waitingForReleaseSendKill=
(0x0297+ 6794-0x1d03));($waitingForRedisDaemonReply=(0x179c+ 1517-0x1d86));(
$waitingForNonDaemonServerReleaseTimeout=(0x10fb+ 2170-0x1911));(
$timeoutForNewDaemonWaiting=(0x046b+ 1765-0x0a60));($waitingForNewDaemonTick=0.5
);($failCounter=(0x09c9+ 465-0x0b9a));($finalizeProcessStarted=
(0x1350+ 2632-0x1d98));($doNotCloseRedisThreadsWhenFreePerl=
(0x0591+ 6199-0x1dc8));($waitForResponseTimeout=(0x0e0c+ 3717-0x1c87));(
$waitIntervalTime=0.1);($maxWaitTimeout=(0x0ec8+ 5406-0x22ba));
@waitingCommandList;@responses;@sendCommandList;($descriptorLimit=
(0x1f9f+ 2752-0x1a5f));($errorDuringLastCommand=(0x0c31+ 3069-0x182e));sub 
initRedisServer{if (($serverInit==(0x00e7+ 255-0x01e6))){(my $cookie=
NXServerDaemon::getCookie ());setNxDirInNXHomeDirOwner ();if (
main::nxPipeCreateBi ((\$daemonRedis),(\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);return;}(my $returnValue=libnxhs::NXRedisServerCreate ($daemonRedis,$cookie,
NXPaths::getRedisDatabaseDirectory (),NXPaths::getNXErrorFile ()));if ((
$returnValue==(0x0348+ 170-0x03f1))){($serverInit=(0x028d+ 2211-0x0b2f));
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x73\x74\x61\x72\x74\x69\x6e\x67\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);}else{Logger::error ((
(
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x69\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x65\x72\x72\x6f\x72\x20\x77\x69\x74\x68\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));(my $error=libnxh::NXGetErrorName ());(my $errorstring=
libnxh::NXGetErrorString ());Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20".
$error)."\x3a\x20").$errorstring)."\x2e"));main::nxexit ();}}elsif ((not (
checkRedisFlock ()))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);removeRedisServerLockFileHandle ();}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x74\x61\x62\x61\x73\x65\x20\x73\x65\x72\x76\x65\x72\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x6f\x6e\x20\x74\x68\x69\x73\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);}}sub auth{my ($cookie);if (($serverInit==(0x1175+ 2747-0x1c30))){($cookie=
NXClientSystemDaemons::getCookieForRedisAuthentication ());}else{($cookie=
NXServerDaemon::getCookie ());}if (($cookie ne (""))){sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x61\x75\x74\x68\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d"
.$cookie)."\x0a"));(my $returnValue=get ());if (($returnValue ne "\x4f\x4b")){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x72\x65\x74\x75\x72\x6e\x20\x76\x61\x6c\x75\x65\x3a\x20"
.$returnValue)."\x2e"));forceCloseRedisClient ();checkFailCounter ();return (
(0x1610+ 2552-0x2007));}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x64\x2e"
);($failCounter=(0x00d8+ 2721-0x0b79));return ((0x1988+ 400-0x1b18));}}else{
forceCloseRedisClient ();checkFailCounter ();Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x41\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x69\x6f\x6e\x20\x63\x6f\x6f\x6b\x69\x65\x20\x69\x73\x20\x65\x6d\x70\x74\x79\x2c\x20\x63\x61\x6e\x6e\x6f\x74\x20\x61\x75\x74\x68\x65\x6e\x74\x69\x63\x61\x74\x65\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);return ((0x0960+ 3589-0x1764));}}sub initRedisClient{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x49\x6e\x69\x74\x69\x61\x6c\x69\x7a\x65\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);if ((($readRedis eq (""))or ($writeRedis eq ("")))){if (
libnxhs::NXRedisClientRunning ()){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x63\x72\x65\x61\x74\x65\x64\x2e"
);Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29"
);(my $FD=libnxhs::NXSubsystemGetRedisFd ());Logger::debug2 (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x53\x75\x62\x73\x79\x73\x74\x65\x6d\x47\x65\x74\x52\x65\x64\x69\x73\x46\x64\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$FD)."\x27\x2e"));if (($FD>=(0x1032+ 5113-0x242b))){($connected=
(0x11c9+ 2483-0x1b7b));($readRedis=$FD);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x69\x6e\x68\x65\x72\x69\x74\x65\x64\x20\x46\x44\x23"
.$FD)."\x2e"));($selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});}else{Logger::warning (
"\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x74\x72\x69\x65\x76\x65\x20\x52\x65\x64\x69\x73\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x2e"
);}if (checkIfSubscriptionShouldBeStarted ()){main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}return;}if ((not (
main::nxPipeCreateBi ((\$readRedis),(\$writeRedis))))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x13ca+ 915-0x175d));}(my $homeDir=NXPaths::getUserNXHomeDir ());
libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$homeDir);Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x28"
.$writeRedis)."\x2c\x20").$writeRedis)."\x29"));(my $rettmp=
libnxhs::NXRedisCreate ($writeRedis,$writeRedis));Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x72\x65\x61\x74\x65\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$rettmp)."\x27\x2e"));Common::NXCore::doNotCloseSocketAtFinish ($writeRedis);}(
$selector=
"\x43\x6f\x6d\x6d\x6f\x6e\x3a\x3a\x4e\x58\x53\x65\x6c\x65\x63\x74\x6f\x72"->new)
;$selector->add ($readRedis);$selector->add ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});if (($serverInit==(0x114a+ 5495-0x26c1))){if ((
NXClientSystemDaemons::openConnection ((0x066d+ 704-0x092c))!=
(0x01f9+ 7319-0x1e8f))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x0719+ 5554-0x1ccb));}if (main::nxPipeCreateBi ((\$daemonRedis),(
\$clientRedis))){Logger::debug (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x72\x65\x61\x74\x65\x64\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x5b"
.$daemonRedis)."\x2f").$clientRedis)."\x5d\x2e"));}else{Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x73\x65\x63\x6f\x6e\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x73\x20\x70\x61\x69\x72\x20\x66\x6f\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x2e"
);return ((0x0eea+ 5517-0x2477));}(my $socketCookie=main::get_unique_id ());(my $tmpDir
=NXPaths::getTmpDir ());(my $socketPath=(($tmpDir.$GLOBAL::DIRECTORY_SLASH).
main::get_unique_id ()));(my $message=(("\x4e\x58\x3e\x20".
$GLOBAL::MSG_REDIS_YIELD)."\x20\x52\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64"));(
$message.=("\x20\x70\x69\x64\x3d".$ $));
 ($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64\x3d".
main::urlencode ($socketPath)));($message.=(
"\x20\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65\x3d".$socketCookie));(
$message.=("\x20\x66\x64\x3d".$daemonRedis));($message.="\x20\x0a");if ((
NXClientSystemDaemons::sendMessage ($message)!=(0x0714+ 1365-0x0c68))){
Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);return ((0x0928+ 5525-0x1ebd));}Server::saveTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65",
"\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x63\x71\x75\x69\x72\x65\x2e"
);(my $response=NXClientSystemDaemons::getDaemonReplyAboutRedis (
$waitingForAcquireTimeout));if (($response ne getMessageStartAcquire ())){if ((
$response eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x74\x69\x6d\x65\x6f\x75\x74\x3a\x20"
.$waitingForAcquireTimeout)."\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));}else{
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20"
.$response)."\x2e"));}NXClientSystemDaemons::closeConnection ();return (
(0x06f8+ 3562-0x14e2));}if ((Common::NXDescriptor::yield ($daemonRedis,
$socketPath,$socketCookie)==(-(0x0984+ 5320-0x1e4b)))){Logger::error (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x79\x69\x65\x6c\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$daemonRedis).
"\x20\x77\x69\x74\x68\x20\x73\x6f\x63\x6b\x65\x74\x20\x70\x61\x74\x68\x20").
$socketPath)."\x2e"));NXClientSystemDaemons::closeConnection ();main::nxexit (
(0x12d0+ 2979-0x1e72));}($response=(""));($response=
NXClientSystemDaemons::getDaemonReplyAboutRedis ($waitingForRedisDaemonReply));
if (($response eq getMessageAcquireFail ())){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x61\x69\x6c\x65\x64\x2e"
);NXClientSystemDaemons::closeConnection ();main::nxexit ((0x0e77+ 5454-0x23c4))
;}if (($response ne getMessageAcquireDone ())){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x63\x6f\x67\x6e\x69\x7a\x65\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x64\x75\x72\x69\x6e\x67\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x3a\x20"
.$response)."\x2e"));NXClientSystemDaemons::closeConnection ();return (
(0x08ac+ 427-0x0a57));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x58\x52\x65\x64\x69\x73\x41\x63\x71\x75\x69\x72\x65\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x66\x74\x65\x72\x20"
.Server::getTimePassedFromSavedTimestamp (
"\x72\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x41\x63\x71\x75\x69\x72\x65")).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x2e"));
Common::NXCore::doNotCloseSocketAtFinish ($daemonRedis);
NXClientSystemDaemons::closeConnection ();Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x70\x61\x73\x73\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x74\x68\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x2e"
);}($connected=(0x1631+ 546-0x1852));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6f\x6e\x6e\x65\x63\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x66\x64\x3d"
.$clientRedis)."\x0a"));if ((get ()eq "\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64")){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);Common::NXCore::doNotCloseSocketAtFinish ($clientRedis);if ((auth ()==
(0x1ea1+ 767-0x219f))){return (initRedisClient ());}($redisServerPid=
__getRedisServerPid ());if (($serverInit==(0x0dab+ 4329-0x1e93))){
main::nxrequire ("\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");
NXRedisScript::loadAllScriptsToDb ();}if (checkIfSubscriptionShouldBeStarted ())
{main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::createSubscriptionClient ();}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e"
);}}sub sendToDb{(my $msg=shift (@_));if ((Server::isDaemonProcess ()and (
$serverInit==(0x0bb3+ 4440-0x1d0b)))){if ((
NXServerDaemon::checkAndSetServerDaemonFlock ()==(0x0f3c+ 2381-0x1889))){
Logger::error (
"\x41\x6e\x6f\x74\x68\x65\x72\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x69\x6e\x73\x74\x61\x6e\x63\x65\x20\x69\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxexit ();}main::nxrequire (
"\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73");if (
NXSystemDaemons::savePid ("\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 Logger::error
 (
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x61\x76\x65\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x2d\x2d\x64\x61\x65\x6d\x6f\x6e\x20\x70\x69\x64\x2e"
);main::nxexit ();}if ((__checkAndSetRedisServerFlock ()==(0x03af+ 342-0x0504)))
{initRedisServer ();($waitingForReleaseCounter=(0x168f+ 4117-0x26a4));}else{if (
($waitingForReleaseCounter>$waitingForReleaseSendKill)){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e\x20\x45\x78\x69\x74\x69\x6e\x67\x2e"
);main::nxexit ((0x261d+ 109-0x268a));}if (($waitingForReleaseCounter==
$waitingForReleaseSendKill)){(my $redisServerPid=__getRedisServerPid ());
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x47\x6f\x69\x6e\x67\x20\x74\x6f\x20\x6b\x69\x6c\x6c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x70\x69\x64\x20"
.$redisServerPid).
"\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
));__killOtherRedisServer ($redisServerPid);}Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4f\x74\x68\x65\x72\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x63\x75\x72\x72\x65\x6e\x74\x6c\x79\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e"
);main::nxsleep (0.5);(++$waitingForReleaseCounter);return (sendToDb ($msg));}}
main::nxrequire ("\x4e\x58\x53\x79\x73\x74\x65\x6d\x44\x61\x65\x6d\x6f\x6e\x73")
;if ((((((($connected==(0x032d+ 157-0x03ca))and (NXSystemDaemons::isShutdownFlag
 ()==(0x066f+ 2446-0x0ffd)))and ($redisServerPid!=(-(0x1424+ 4357-0x2528))))and 
($serverInit==(0x06b5+ 7865-0x256e)))and (NXServerDaemon::checkDaemonFlock ()==
(0x15c4+ 1602-0x1c05)))and ($finalizeProcessStarted==(0x211f+ 784-0x242f)))){(++
$waitingForNewDaemonCounter);main::nxsleep ($waitingForNewDaemonTick);if ((
$waitingForNewDaemonCounter>=$timeoutForNewDaemonWaiting)){($redisServerPid=(-
(0x0d47+ 2279-0x162d)));(my $logTimeout=($waitingForNewDaemonCounter *
$waitingForNewDaemonTick));($waitingForNewDaemonCounter=(0x0811+ 4768-0x1ab1));
Logger::error (((
"\x53\x65\x72\x76\x65\x72\x20\x6c\x6f\x73\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x6e\x64\x20\x74\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x6e\x65\x77\x20\x6f\x6e\x65\x20"
.$logTimeout).
"\x20\x73\x65\x63\x6f\x6e\x64\x73\x20\x72\x65\x61\x63\x68\x65\x64\x2e"));closeDb
 ((0x01ff+ 8643-0x23c1));main::nxexit ((0x0acc+ 5162-0x1ef5));}else{return (
sendToDb ($msg));}}($waitingForNewDaemonCounter=(0x071a+ 3080-0x1322));if ((((
$connected==(0x1366+ 2957-0x1ef3))and ($serverInit==(0x0358+ 8870-0x25fe)))and (
not (Server::isDaemonProcess ())))){if ((NXSystemDaemons::isShutdownFlag ()==
(0x0377+ 5515-0x1901))){if ((__checkAndSetRedisServerFlock ()==
(0x03b4+ 1982-0x0b71))){initRedisServer ();($waitingForReleaseCounter=
(0x072f+ 724-0x0a03));}else{removeRedisServerLockFileHandle ();if ((
$waitingForReleaseCounter==$waitingForNonDaemonServerReleaseTimeout)){
Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x0891+ 1686-0x0f27));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x6f\x6e\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}elsif ((NXServerDaemon::checkDaemonFlock ()==
(0x0e44+ 5938-0x2575))){if ((($GLOBAL::isNXServerLoginProcess==
(0x1fbd+ 1178-0x2457))or (($GLOBAL::isNXServerLoginProcess==
(0x047b+ 1553-0x0a8b))and ($finalizeProcessStarted==(0x1cf3+ 1904-0x2462))))){if
 ((__checkAndSetRedisServerFlock ()==(0x0553+ 1725-0x0c0f))){initRedisServer ();
($waitingForReleaseCounter=(0x05e7+ 6252-0x1e53));}else{
removeRedisServerLockFileHandle ();if (($waitingForReleaseCounter==
$waitingForNonDaemonServerReleaseTimeout)){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2c\x20\x6f\x74\x68\x65\x72\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x64\x69\x64\x20\x6e\x6f\x74\x20\x72\x65\x6c\x65\x61\x73\x65\x20\x64\x61\x74\x61\x62\x73\x65\x2e"
);return ((0x04b6+ 3203-0x1139));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x74\x61\x72\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x6e\x6f\x74\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x62\x75\x74\x20\x74\x68\x65\x72\x65\x20\x69\x73\x20\x6c\x6f\x63\x6b\x20\x6f\x6e\x20\x66\x69\x6c\x65\x2e"
);main::nxsleep ($waitIntervalTime);(++$waitingForReleaseCounter);return (
sendToDb ($msg));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x20\x61\x73\x20\x6c\x6f\x67\x69\x6e\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
);checkFailCounter ();return ((0x1b3a+ 2753-0x25fb));}}else{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x44\x61\x65\x6d\x6f\x6e\x20\x69\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x20\x63\x72\x65\x61\x74\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}}if (($connected==(0x02cb+ 5078-0x16a1))){initRedisClient ();}if (($connected
==(0x04aa+ 2340-0x0dce))){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x0310+ 4097-0x1311));}if ((__checkCommandLine ((\$msg))==
(0x16e4+ 1545-0x1cec))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$msg)."\x27\x20\x61\x62\x6f\x72\x74\x65\x64\x2e"));return (
(0x091f+ 2068-0x1133));}Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x6e\x64\x69\x6e\x67\x20\x27".$msg)
."\x27\x2e"));if ((main::nxwrite ($readRedis,$msg)==(-(0x113f+ 5424-0x266e)))){
if (($retry==(0x1222+ 1311-0x1741))){closeDb ();($retry=(0x2567+  17-0x2577));
sendToDb ($msg);}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x6d\x65\x73\x73\x61\x67\x65\x3a\x20\x27"
.$msg).
"\x27\x2e\x20\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x20\x75\x6e\x61\x76\x61\x69\x6c\x61\x62\x6c\x65\x2e"
));return ((0x00c7+ 7722-0x1ef1));}}($retry=(0x09d1+ 391-0x0b58));push (
@sendCommandList,$msg);return ((0x1102+ 1298-0x1613));}sub sendToDbAndSave{(my $msg
=shift (@_));if ((sendToDb ($msg)==(0x194b+ 937-0x1cf3))){saveDb ();}}sub 
sendToDbAndGetReply{(my $request=shift (@_));if ((sendToDb ($request)==
(0x00a0+ 5034-0x1449))){return (split ( / / ,get (),(0x010b+ 655-0x039a)));}
return (undef);}sub readFromDb{my ($read_buf);(my $bytes_read=main::nxread (
$readRedis,(\$read_buf),32768));if ((($bytes_read eq (0x10a3+ 3678-0x1f01))or (
$bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x148c+ 4175-0x24db));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x63\x65\x69\x76\x65\x64\x20\x64\x61\x74\x61\x20\x6f\x6e\x20\x52\x65\x64\x69\x73\x20\x73\x6f\x63\x6b\x65\x74\x3a\x20\x27"
.$response)."\x27\x2e"));parseRedisOutput ($response);}}sub get{(my $callbackTimeout
=(shift (@_)||(0x09e0+ 6179-0x2203)));(my $ref_timeoutCallback=shift (@_));if ((
$sendCommandList[-(0x0f42+ 4832-0x2221)]eq (""))){return ((""));}push (
@waitingCommandList,$sendCommandList[-(0x07b7+ 5739-0x1e21)]);(my $tmpLastCommand
=__getCommandNameFromLine ($sendCommandList[-(0x17c1+ 257-0x18c1)]));my (
$returnValue);if ((waitForReponse ($callbackTimeout,$ref_timeoutCallback)==
(0x1cd8+ 443-0x1e92))){($returnValue=pop (@responses));($failCounter=
(0x0b95+ 4292-0x1c59));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{
if ((checkFailure ()==(0x0863+ 1973-0x1018))){if ((waitForReponse (
$callbackTimeout,$ref_timeoutCallback)==(0x00b1+ 5195-0x14fb))){($returnValue=
pop (@responses));($failCounter=(0x1c53+ 1117-0x20b0));Logger::debug3 (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x27"
.$tmpLastCommand)."\x27\x20\x69\x73\x20\x27").$returnValue)."\x27\x2e"));}else{(
@waitingCommandList=());(@responses=());shift (@sendCommandList);Logger::error (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x61\x66\x74\x65\x72\x20\x72\x65\x73\x65\x6e\x64\x69\x6e\x67\x2e"));}}else{
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x6f\x75\x74\x70\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.$tmpLastCommand).
"\x20\x52\x65\x73\x65\x6e\x64\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x20\x66\x61\x69\x6c\x65\x64\x2e"
));}}return ($returnValue);}sub getWithCallbackOnTimeout{(my $callbackTimeout=
shift (@_));(my $ref_timeoutCallback=shift (@_));if (($maxWaitTimeout<
$callbackTimeout)){return (get ());}(my $defaultTimeout=$waitForResponseTimeout)
;($waitForResponseTimeout=$maxWaitTimeout);(my $result=get ($callbackTimeout,
$ref_timeoutCallback));($waitForResponseTimeout=$defaultTimeout);return ($result
);}sub waitForReponse{(my $callbackTimeout=(shift (@_)||(0x1cbb+ 541-0x1ed8)));(my $ref_timeoutCallback
=shift (@_));(my $waitTime=(0x1659+ 3763-0x250c));(my $waitForResponseTimeout=(
$waitForResponseTimeout *(0x0ddc+ 7388-0x26d0)));(my $maxSelectTimeout=
$waitForResponseTimeout);if ($callbackTimeout){($maxSelectTimeout=
$callbackTimeout);}if (((__getCommandNameFromLine ($waitingCommandList[
(0x0548+ 8133-0x250d)])eq "\x61\x75\x74\x68")or (__getCommandNameFromLine (
$waitingCommandList[(0x08bc+ 7739-0x26f7)])eq "\x65\x76\x61\x6c\x73\x68\x61"))){
($waitForResponseTimeout=(($NXRedis::waitForResponseTimeout *
(0x1098+ 4750-0x1f3e))*(0x16f0+ 3171-0x234d)));($maxSelectTimeout=
$waitForResponseTimeout);}($selectTimeout=$maxSelectTimeout);(my $startTime=
Common::NXTime::getMillisecondsSinceEpoch ());(my $lastTimeoutCallbackCall=
(0x1380+ 1123-0x17e3));while (((@waitingCommandList and ($waitTime<
$waitForResponseTimeout))and (($connected==(0x0e06+ 4647-0x202c))||(
__getCommandNameFromLine ($waitingCommandList[(0x0fa8+ 4572-0x2184)])eq 
"\x63\x6f\x6e\x6e\x65\x63\x74")))){(my (@ready)=$selector->can_read (
$selectTimeout));foreach my $fh (@ready){if (($fh eq $readRedis)){if (
@waitingCommandList){readFromDb ();}}}if (@waitingCommandList){if ((
$resendSuccess==(0x053f+ 1762-0x0c20))){($waitTime=(0x0285+ 4019-0x1238));(
$selectTimeout=$maxSelectTimeout);($startTime=
Common::NXTime::getMillisecondsSinceEpoch ());($resendSuccess=
(0x0cfc+ 1927-0x1483));}else{($waitTime=(
Common::NXTime::getMillisecondsSinceEpoch ()-$startTime));if ($callbackTimeout){
if ((($waitTime+$selectTimeout)>$waitForResponseTimeout)){($selectTimeout=(
$waitForResponseTimeout-$waitTime));}}else{($selectTimeout=($maxSelectTimeout-
$waitTime));}}if ($callbackTimeout){if ((($lastTimeoutCallbackCall+
$callbackTimeout)<Common::NXTime::getSecondsSinceEpoch ())){&{
$ref_timeoutCallback;}();($lastTimeoutCallbackCall=
Common::NXTime::getSecondsSinceEpoch ());}}}}if (($connected!=
(0x00bb+ 6721-0x1afb))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x69\x65\x6e\x74\x20\x77\x61\x73\x20\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2c\x20\x71\x75\x69\x74\x20\x77\x61\x69\x74\x69\x6e\x67\x2e"
);return ((0x0657+ 2843-0x1172));}if (@waitingCommandList){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x69\x6d\x65\x6f\x75\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x04a8+ 2598-0x0ece)])).((
"\x20\x77\x68\x69\x63\x68\x20\x69\x73\x20".$NXRedis::waitForResponseTimeout).
"\x20\x68\x61\x73\x20\x62\x65\x65\x6e\x20\x72\x65\x61\x63\x68\x65\x64\x2e")));
checkFailCounterAndCloseIfNeeded ();return ((0x06d6+ 3688-0x153e));}return (
(0x0009+ 1240-0x04e0));}sub parseRedisOutput{(my $output=shift (@_));($output.=
"\x20");(my (@lines)=split ( /\n/ ,$output,(0x0a0b+ 6097-0x21dc)));while (@lines
){(my $line=shift (@lines));if (($line=~ /event=disconnected,error=0/ )){(
$connected=(0x2103+ 140-0x218f));next;}(my $response=shift (@lines));unless (
@sendCommandList){return;}my ($firstWaitingCommand);if (@waitingCommandList){(
$firstWaitingCommand=__getCommandNameFromLine ($waitingCommandList[
(0x0f9f+ 1667-0x1622)]));}if ((handleCommandSuccesful ($line)==
(0x0568+ 4156-0x15a3))){return;}if (($line=~ /command=connect,error=0/ )){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6e\x6e\x65\x63\x74\x65\x64\x2e");
($connected=(0x13ec+ 2723-0x1e8e));shift (@waitingCommandList);push (@responses,
"\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");next;}elsif (($line=~ /command=connect,error=/ )
){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4e\x6f\x74\x20\x63\x6f\x6e\x6e\x65\x63\x74\x2e"
);shift (@waitingCommandList);push (@responses,
"\x64\x69\x73\x63\x6f\x6e\x6e\x65\x63\x74\x65\x64");($connected=
(0x05c6+ 3903-0x1505));next;}elsif ((($line=~ /command=(.*),error=0/ )and (
$response ne ("")))){(my $command=$1);if (($command eq $firstWaitingCommand)){(my $fullResponse
=$response);if (($command eq "\x63\x6c\x69\x65\x6e\x74")){while ((@lines and (
$lines[(0x106f+ 4554-0x2239)]=~ /^id=/ ))){($fullResponse.=("\x0a".shift (@lines
)));}}push (@responses,$fullResponse);shift (@waitingCommandList);next;}else{
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=(.*),error=0,size=0/ )
and ($response eq ("")))){(my $command=$1);if (($command eq $firstWaitingCommand
)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6e\x6f\x20\x76\x61\x6c\x75\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.__getCommandNameFromLine ($waitingCommandList[(0x04e2+ 285-0x05ff)])).
"\x20\x73\x61\x76\x65\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"))
;push (@responses,(""));shift (@waitingCommandList);next;}else{Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$firstWaitingCommand)."\x2e"));}}elsif ((($line=~ /command=bgsave,error=1/ )and
 ($response=~ /ERR Background save already in progress/ ))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x61\x76\x69\x6e\x67\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x69\x6e\x20\x70\x72\x6f\x67\x72\x65\x73\x73\x2c\x20\x73\x6b\x69\x70\x69\x6e\x67\x2e"
);push (@responses,(""));shift (@waitingCommandList);shift (@sendCommandList);
next;}elsif (($line=~ /command=(.*),error=(.*)/ )){(my $error=$2);(
$errorDuringLastCommand=(0x18d4+ 2312-0x21db));if (($error ne (""))){if ((
__handleRedisErrorIfPossible ($response)==(0x0b93+ 6882-0x2674))){return;}
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x0665+ 4976-0x19d5)])).((((
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x3a\x20").$response).
"\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
)));}else{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x27".
__getCommandNameFromLine ($sendCommandList[(0x10c3+ 2920-0x1c2b)])).
"\x27\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x20\x72\x65\x64\x69\x73\x2e\x20\x4d\x6f\x72\x65\x20\x69\x6e\x66\x6f\x72\x6d\x61\x74\x69\x6f\x6e\x20\x69\x6e\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x2e\x6c\x6f\x67\x2e"
));}($connected=(0x02b3+ 4895-0x15d2));}elsif (($line eq (""))){next;}elsif ((
$response=~ /event=disconnected,error=0/ )){($connected=(0x0725+ 4532-0x18d9));
next;}}}sub getRedisDescriptor{return ($readRedis);}sub saveDb{Logger::debug (
"\x53\x61\x76\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);if (($serverInit==(0x0509+ 5592-0x1ae0))){sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}else{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x62\x67\x73\x61\x76\x65\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}(my $saveResponse=get ());}sub closeDb{(my $finalizeProcess=(shift (@_)||
(0x1d22+ 2336-0x2642)));if (($finalizeProcess==(0x1073+ 3491-0x1e15))){(
$finalizeProcessStarted=(0x03ba+ 301-0x04e6));}Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x64\x62\x2e"
);while ((scalar (@sendCommandList)>(0x13b1+ 2739-0x1e64))){(my $command=
__getCommandNameFromLine ($sendCommandList[(0x0e1b+ 6116-0x25ff)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command).
"\x27\x20\x62\x65\x66\x6f\x72\x65\x20\x63\x6c\x6f\x73\x69\x6e\x67\x2e"));get ();
}if (($doNotCloseRedisThreadsWhenFreePerl==(0x1859+ 277-0x196d))){Logger::debug 
(
"\x4c\x65\x61\x76\x69\x6e\x67\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x63\x6c\x69\x65\x6e\x74\x20\x61\x6e\x64\x20\x72\x65\x64\x69\x73\x20\x73\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e\x20\x74\x68\x72\x65\x61\x64\x2e"
);return;}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x75\x62\x73\x63\x72\x69\x70\x74\x69\x6f\x6e");
NXRedisSubscription::closeSubscription ();if (($connected==(0x109c+ 1897-0x1804)
)){Logger::debug (
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29"
);(my $returnValue=libnxhs::NXRedisClientDestroy ());Logger::debug (((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6c\x69\x65\x6e\x74\x44\x65\x73\x74\x72\x6f\x79\x28\x29\x20\x72\x65\x74\x75\x72\x6e\x73\x20\x27"
.$returnValue)."\x27\x2e"));Common::NXSelector::removeFromGlobalSelector (
$readRedis);($readRedis=(""));($connected=(0x14c9+ 3009-0x208a));}if ((
$serverInit==(0x0a6c+ 7024-0x25db))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);if ((libnxhs::NXRedisServerDestroy ()==(0x0410+ 7982-0x233d))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x65\x72\x76\x65\x72\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);removeRedisServerLockFileHandle ();(my $redisLock=getRedisLockFile ());if ((
not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $redisPidFile=getRedisPidFile ());if ((not (
unlink ($redisPidFile)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}(my $dbFile=NXPaths::getRedisDatabaseFile ());if 
(Common::NXFile::fileExists ($dbFile)){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($dbFile,(\$errorMsg))==(-
(0x0a56+  66-0x0a97)))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x27"
.$dbFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x63\x6c\x6f\x73\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x2e"
);}($serverInit=(0x0a13+ 4460-0x1b7f));}}sub isRedisDatabaseInit{if (
Server::isDaemonProcess ()){if (($serverInit==(0x140c+ 1684-0x1a9f))){return (
(0x2048+ 356-0x21ab));}else{return ((0x1729+ 3360-0x2449));}}if (
isRedisLockFileExist ()){return ((0x0ce4+ 2637-0x1730));}else{return (
(0x1ce3+ 1615-0x2332));}}sub getRedisLockFile{(my $redisLockFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH)."\x72\x65\x64\x69\x73"))
;return ($redisLockFile);}sub getRedisPidFile{(my $redisPidFile=((((((
$GLOBAL::VAR_ROOT.$GLOBAL::DIRECTORY_SLASH)."\x64\x62").$GLOBAL::DIRECTORY_SLASH
)."\x73\x65\x72\x76\x65\x72").$GLOBAL::DIRECTORY_SLASH).
"\x72\x65\x64\x69\x73\x2e\x70\x69\x64"));return ($redisPidFile);}sub 
isRedisLockFileExist{(my $file=getRedisLockFile ());if (
Common::NXFile::fileExists ($file)){return ((0x0a6b+ 3954-0x19dc));}else{return 
((0x1579+ 3521-0x233a));}}sub isNotRedisDatabaseInit{return ((!
isRedisDatabaseInit ()));}sub daemonAcquire{(my $message=shift (@_));(my $socket
=shift (@_));(my (%parameters)=());(my $redisDescriptor=(-(0x173d+ 2348-0x2068))
);if (($serverInit==(0x07a7+ 5411-0x1cca))){return ((0x1055+ 5589-0x2629));}if (
($message=~ /Redis yield/ )){($message=~ s/Redis yield // );(my (@args)=split ( / / ,
$message,(0x0d8d+ 3516-0x1b49)));foreach my $pair (@args){(my ($key,$value)=
split ( /=/ ,$pair,(0x05a3+ 5585-0x1b71)));($parameters{$key}=$value);}(my $socketPath
=main::urldecode ($parameters{
"\x73\x6f\x63\x6b\x65\x74\x50\x61\x74\x68\x45\x6e\x63\x6f\x64\x65\x64"}));(my $msg
=getMessageStartAcquire ());if ((main::nxwrite ($socket,$msg)==(-
(0x122b+  60-0x1266)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x72\x65\x61\x64\x79\x2e"
));return ((0x0507+ 202-0x05d0));}($redisDescriptor=
Common::NXDescriptor::acquire ($parameters{"\x70\x69\x64"},$parameters{
"\x66\x64"},$socketPath,$parameters{
"\x73\x6f\x63\x6b\x65\x74\x43\x6f\x6f\x6b\x69\x65"}));if ((($redisDescriptor<
(0x19fa+ 2911-0x2559))or ($redisDescriptor>$descriptorLimit))){Logger::warning (
((((
"\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"})."\x20\x61\x6e\x64\x20").$socketPath)."\x2e"));(
$msg=getMessageAcquireFail ());if ((main::nxwrite ($socket,$msg)==(-
(0x05e3+ 6835-0x2095)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x66\x61\x69\x6c\x2e"
));}return ((0x1613+ 3569-0x2403));}Common::NXCore::doNotCloseSocketAtFinish (
$redisDescriptor);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x53\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x63\x65\x69\x76\x65\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x46\x44\x23"
.$redisDescriptor)."\x20\x66\x72\x6f\x6d\x20\x73\x65\x72\x76\x65\x72\x2e"));(my $return
=libnxhs::NXRedisServerConnection ($redisDescriptor));Logger::debug (((((
"\x6c\x69\x62\x6e\x78\x68\x73\x3a\x3a\x4e\x58\x52\x65\x64\x69\x73\x43\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x28"
.$redisDescriptor)."\x29\x20").$return)."\x2e"));($msg=getMessageAcquireDone ())
;if ((main::nxwrite ($socket,$msg)==(-(0x0aeb+ 5019-0x1e85)))){Logger::warning (
((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x46\x61\x69\x6c\x65\x64\x20\x74\x6f\x20\x69\x6e\x66\x6f\x72\x6d\x20\x73\x65\x72\x76\x65\x72\x20"
.$parameters{"\x70\x69\x64"}).
"\x20\x61\x62\x6f\x75\x74\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x6f\x6e\x65\x2e"
));}return ((0x0841+ 3169-0x14a2));}else{Logger::error (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x68\x61\x6e\x64\x6c\x65\x20\x72\x65\x64\x69\x73\x20\x79\x69\x65\x6c\x64\x20\x72\x65\x71\x75\x65\x73\x74\x3a\x20"
.$message)."\x2e"));return ((0x0a7d+ 1238-0x0f52));}}sub 
isDbRunningInCurrentProcess{return ($serverInit);}sub __lockFile{(my $file=
getRedisLockFile ());my ($errormsg);(my $SERVER_FH=main::nxopen ($file,(
$NXBits::O_WRONLY+$NXBits::O_CREAT),(($NXBits::UserReadWrite+$NXBits::GroupRead)
+$NXBits::OthersRead)));if ((not (defined ($SERVER_FH)))){(my $serverDir=
Common::NXFile::dirname ($file));if ((Common::NXFile::directoryExists (
$serverDir)==(0x0b55+ 5919-0x2274))){my ($errorMessage);if (
Common::NXPaths::makePath ((\$errorMessage),$serverDir)){if ((
Common::NXFile::setOwnershipForUserNX ($serverDir,(\$errorMessage))==(-
(0x0b94+ 5862-0x2279)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}if ((Common::NXFile::setPermissionsFullForNXDirectory ($serverDir,(
\$errorMessage))==(-(0x18b3+ 1617-0x1f03)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x63\x6f\x72\x72\x65\x63\x74\x20\x70\x65\x72\x6d\x69\x73\x73\x69\x6f\x6e\x73\x20\x66\x6f\x72\x20\x75\x73\x65\x72\x20\x4e\x58\x20\x66\x6f\x72\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}($SERVER_FH=main::nxopen ($file,($NXBits::O_WRONLY+$NXBits::O_CREAT),(
($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));}else{
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$serverDir)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMessage).
"\x2e"));}}if ((not (defined ($SERVER_FH)))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x27"
.$file)."\x27\x20\x66\x6f\x72\x20\x77\x72\x69\x74\x69\x6e\x67\x2e"));return ((-
(0x08dd+ 2581-0x12f1)));}}unless (main::nxflock ($SERVER_FH,$NXBits::LOCK_EX)){
Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20"
.$file)."\x2e"));return ((-(0x0d38+ 6377-0x2620)));}
Common::NXFile::setOwnershipForUserNX ($file,(\$errormsg));if (($errormsg ne 
(""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x68\x61\x6e\x67\x65\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x6f\x72\x20\x72\x65\x64\x69\x73\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$errormsg)."\x2e"));}libnxh::NXDescriptorInheritable ($SERVER_FH,
(0x064c+ 2657-0x10ad));main::closeSocketAtFinish ($SERVER_FH);return ($SERVER_FH
);}sub __checkAndSetRedisServerFlock{if (($serverInit==(0x07f3+ 6617-0x21cb))){
return ((0x09f2+ 3864-0x190a));}if ((not (checkRedisFlock ()))){return (
(0x0878+ 3237-0x151d));}else{unless ((main::effectiveUserIsAdministrator ()or (
Common::NXCore::getEffectiveUsername ()eq "\x6e\x78"))){if ((
NXSystemDaemons::isShutdownFlag ()==(0x14e6+ 3990-0x247b))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x69\x6e\x75\x65\x2c\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x69\x73\x20\x73\x68\x75\x74\x64\x6f\x77\x6e\x20\x61\x6e\x64\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x6f\x70\x65\x72\x61\x74\x69\x6f\x6e\x20\x72\x65\x71\x75\x69\x72\x65\x73\x20\x72\x75\x6e\x6e\x69\x6e\x67\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
);NXMsg::error (
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,"\x4e\x58\x52\x65\x64\x69\x73");main::nxexit ((0x14eb+ 322-0x162d));}}(my $file
=getRedisLockFile ());unlink ($file);(my $fh=__lockFile ());if (($fh==(-
(0x0210+ 3921-0x1160)))){return ((0x0709+ 5339-0x1be4));}
setRedisServerLockFileHandle ($fh);saveRedisPid ();return ((0x09bc+ 6049-0x215c)
);}}sub checkRedisFlock{if (($serverInit==(0x2305+ 269-0x2411))){return (
(0x1573+ 2839-0x208a));}(my $file=getRedisLockFile ());Logger::debug (((
"\x43\x68\x65\x63\x6b\x69\x6e\x67\x20\x72\x65\x64\x69\x73\x20\x66\x69\x6c\x65\x20\x6c\x6f\x63\x6b\x3a\x20"
.$file)."\x2e"));if ((Common::NXFile::fileExists ($file)==(0x0a1d+  51-0x0a50)))
{Logger::debug ((("\x46\x69\x6c\x65\x20".$file).
"\x20\x64\x6f\x65\x73\x20\x6e\x6f\x74\x20\x65\x78\x69\x73\x74\x2e"));return (
(0x0b1f+ 4369-0x1c2f));}(my $SERVER_FH=main::nxopen ($file,$NXBits::O_RDONLY,
(0x0697+ 5159-0x1abe)));if ((not (defined ($SERVER_FH)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));return ((0x074d+ 3250-0x13ff));}if ((not (Common::NXCore::nxTryLock (
$SERVER_FH,$NXBits::LOCK_EX)))){Logger::debug (((
"\x43\x61\x6e\x6e\x6f\x74\x20\x6c\x6f\x63\x6b\x20\x66\x69\x6c\x65\x3a\x20".$file
)."\x2e"));main::nxclose ($SERVER_FH);if ((not (Server::isDaemonProcess ()))){
checkFailCounter ();}return ((0x09e7+ 2325-0x12fc));}main::nxclose ($SERVER_FH);
return ((0x08fb+ 5478-0x1e60));}sub removeRedisServerLockFileHandle{if ((
$lockFileHandle!=(-(0x1ae1+ 921-0x1e79)))){main::nxclose ($lockFileHandle);(
$lockFileHandle=(-(0x1068+ 4594-0x2259)));}}sub setRedisServerLockFileHandle{(
$lockFileHandle=shift (@_));}sub setNxDirInNXHomeDirOwner{(my $path=
NXPaths::getUserNXHomeDir ());my ($errorMsg);if (($path eq (""))){return (
(0x19c7+ 833-0x1d08));}if ((Common::NXFile::directoryExists ($path)==
(0x0ea2+ 5231-0x2311))){if ((not (Common::NXPaths::makePath ((\$errorMsg),$path)
))){Logger::warning (((((
"\x43\x61\x6e\x6e\x6f\x74\x20\x63\x72\x65\x61\x74\x65\x20\x64\x69\x72\x65\x63\x74\x6f\x72\x79\x20"
.$path)."\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20").$errorMsg)."\x2e"));
return ((0x046c+ 1826-0x0b8e));}}Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));libnxh::NXTransSetEnvironment ("\x48\x4f\x4d\x45",$path);($path.=(
$GLOBAL::DIRECTORY_SLASH."\x2e\x6e\x78"));if ((Common::NXFile::directoryExists (
$path)==(0x0112+ 3879-0x1039))){Common::NXPaths::createAccessibleForNXDirectory 
((\$errorMsg),$path);}else{Common::NXFile::setOwnershipForUserNX ($path,(
\$errorMsg));Common::NXFile::setPermissionsFullForNXDirectory ($path,(\$errorMsg
));}}sub getMessageStartAcquire{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x73\x74\x61\x72\x74\x65\x64\x20\x61\x63\x71\x75\x69\x72\x65\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x2e"
);return ($msg);}sub getMessageAcquireDone{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x61\x64\x64\x65\x64\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub getMessageAcquireFail{(my $msg=
"\x4e\x58\x52\x65\x64\x69\x73\x20\x63\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x61\x64\x64\x20\x64\x65\x73\x63\x72\x69\x70\x74\x6f\x72\x20\x74\x6f\x20\x72\x65\x64\x69\x73\x2e"
);return ($msg);}sub __killOtherRedisServer{(my $serverPid=shift (@_));if (
NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigterm (
$serverPid)){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x54\x65\x72\x6d\x69\x6e\x61\x74\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x54\x45\x52\x4d\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}(my $result=Common::NXProcess::waitProcess ($serverPid,
(0x0f70+ 1781-0x1656)));if (NXTerminate::checkProcessBeforeKill ($serverPid,
"\x6e\x78\x73\x65\x72\x76\x65\x72",$ $)) {
 if (Common::NXProcess::sigkill (
$serverPid)){if ((not (unlink ($redisLock)))){Logger::warning ((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x6f\x75\x6c\x64\x20\x6e\x6f\x74\x20\x75\x6e\x6c\x69\x6e\x6b\x20\x66\x69\x6c\x65\x20"
.$redisLock)."\x2e\x20").$!));}Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x4b\x69\x6c\x6c\x65\x64\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x6e\x64\x20\x53\x49\x47\x4b\x49\x4c\x4c\x20\x74\x6f\x20\x6e\x78\x73\x65\x72\x76\x65\x72\x20\x77\x68\x69\x63\x68\x20\x6b\x65\x65\x70\x74\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x77\x69\x74\x68\x20\x50\x49\x44\x20"
.$serverPid)."\x2e"));}}}}sub __getRedisServerPid{(my $redisLockFile=
getRedisPidFile ());(my $pid=(-(0x1729+ 3309-0x2415)));my ($FH);($FH=
main::nxopen ($redisLockFile,$NXBits::O_RDONLY,(0x05f7+ 1182-0x0a95)));if ((not 
(defined ($FH)))){(my $errorstring=libnxh::NXGetErrorString ());Logger::error ((
(((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x3a\x20"
.$redisLockFile)."\x3a\x20").$errorstring)."\x2e"));return ((""));}else{(my $r_b
=main::nxread ($FH,(\$pid),(0x1885+ 4083-0x2678)));main::nxclose ($FH);if (($r_b
==(0x0cb3+ 557-0x0ee0))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x66\x69\x6e\x64\x20\x70\x69\x64\x20\x69\x6e\x3a\x20"
.$redisLockFile)."\x2e"));}}return ($pid);}sub __getCommandNameFromLine{(my $cmdLine
=shift (@_));(my $commandName=(""));(($commandName)=($cmdLine=~ /command=(.*),service/ )
);if (($commandName eq (""))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x67\x65\x74\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6e\x61\x6d\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$cmdLine)."\x27\x2e"));}return ($commandName);}sub __checkCommandLine{(my $ref_msg
=shift (@_));(my $msg=$$ref_msg);if ((($msg=~ /key=\n/ )or ($msg=~ /key=,/ ))){
Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6b\x65\x79\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));
return ((0x1ae5+ 1149-0x1f61));}if ((($msg=~ / / )and (not (($msg=~ /command=script,service=db,/ )
)))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x63\x6f\x6e\x74\x61\x69\x6e\x20\x73\x70\x61\x63\x65\x73\x2e"
));return ((0x1bb0+ 2293-0x24a4));}if (($msg=~ /^(.*),field=(.*),value=,/ )){
Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=,/,/ );return (__checkCommandLine ($ref_msg));}if 
(($msg=~ /^(.*),field=(.*),value=\n/ )){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x69\x65\x6c\x64\x20".$2).
"\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27").$msg
)."\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"));(
$$ref_msg=~ s/,field=$2,value=\n/\n/ );return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /=,/ )or ($msg=~ /=\n/ ))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x65\x6d\x70\x74\x79\x20\x66\x69\x65\x6c\x64\x20\x69\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg)."\x27\x2e"));return ((0x01f4+ 3619-0x1016));}if ((not (($msg=~ /\n$/ ))))
{Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x69\x73\x73\x69\x6e\x67\x20\x6e\x65\x77\x20\x6c\x69\x6e\x65\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x20\x61\x74\x20\x74\x68\x65\x20\x65\x6e\x64\x20\x6f\x66\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x27"
.$msg)."\x27\x2e"));($$ref_msg.="\x0a");return (__checkCommandLine ($ref_msg));}
if ((($msg=~ /command=(hmset|hset|set),service=db/ )and ((not (($msg=~ /field=(.*)/ )
))and (not (($msg=~ /value=(.*)/ )))))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x6c\x69\x6e\x65\x20\x27"
.$msg).
"\x27\x20\x63\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6e\x6f\x74\x68\x69\x6e\x67\x2e"
));return ((0x03a7+ 7169-0x1fa7));}if (((length ($msg)>16383)and (not (($msg=~ /command=evalsha,service=db,/ )
)))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x6d\x65\x73\x73\x61\x67\x65\x20\x69\x73\x20\x6c\x6f\x6e\x67\x65\x72\x20\x74\x68\x61\x74\x20\x63\x75\x72\x72\x65\x6e\x74\x20\x6d\x61\x78\x20\x63\x68\x61\x72\x61\x63\x74\x65\x72\x73\x20\x73\x65\x74\x74\x69\x6e\x67\x73\x3a\x20\x31\x36\x33\x38\x33\x2e"
);return ((0x0e06+ 165-0x0eaa));}return ((0x15af+ 4211-0x2622));}sub 
resendWaitingCommands{(my $resend=(0x199b+ 1808-0x20ab));(my (@newCommandList)=
());unless (@sendCommandList){return ((0x0711+ 4509-0x18ae));}(my (
@tmpCommandList)=@sendCommandList);(@waitingCommandList=());(@sendCommandList=()
);foreach my $command (@tmpCommandList){if (($command=~ /command=connect/ )){
next;}if (($command=~ /command=auth/ )){next;}if ((sendToDb ($command)==
(0x02c9+ 5558-0x187f))){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x63\x61\x6e\x6e\x6f\x74\x20\x72\x65\x73\x65\x6e\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$command)."\x2e"));last;}else{push (@newCommandList,$command);}}if (
@newCommandList){Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x73\x75\x63\x63\x65\x73\x73\x66\x75\x6c\x6c\x79\x20\x72\x65\x73\x65\x6e\x64\x20"
.join ($",@newCommandList))."\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x73\x2e"));(
$resendSuccess=(0x0840+ 3490-0x15e1));(@waitingCommandList=@newCommandList);(
@sendCommandList=@newCommandList);return ((0x0b87+ 1850-0x12c0));}return (
(0x069f+ 1530-0x0c99));}sub checkFailure{if (checkRedisFlock ()){($connected=
(0x0330+ 4051-0x1303));(my $redisLockFile=getRedisLockFile ());if ((
Common::NXFile::fileExists ($redisLockFile)==(0x0364+ 4218-0x13dd))){unlink (
$redisLockFile);}}if ((($connected==(0x1314+ 3769-0x21cd))or (
__checkIfActualRedisServerPid ()==(0x0077+ 9193-0x2460)))){($connected=
(0x040c+ 1563-0x0a27));$selector->remove ($readRedis);$selector->remove (
$$NXBegin::parser{"\x53\x69\x67\x6e\x61\x6c"});if ((resendWaitingCommands ()==
(0x0d27+ 6511-0x2695))){return ((0x0386+ 4379-0x14a1));}return (
(0x12a7+ 1612-0x18f2));}return ((0x0fdf+ 2375-0x1926));}sub 
__checkIfActualRedisServerPid{my ($actualRedisServerPid);if (($redisServerPid==(
-(0x0862+ 2921-0x13ca)))){return ((0x0ab4+ 2357-0x13e9));}if ((
Common::NXFile::fileExists (getRedisLockFile ())==(0x076c+ 4479-0x18ea))){(
$actualRedisServerPid=__getRedisServerPid ());}else{return (
(0x024d+ 9069-0x25ba));}if (($actualRedisServerPid==$redisServerPid)){return (
(0x0671+ 5193-0x1ab9));}return ((0x0b67+ 2089-0x1390));}sub 
prepareMultipleCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x75\x6c\x74\x69\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommands{sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub executeCommandsAndSave{sendToDbAndSave (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x65\x78\x65\x63\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);}sub isConnected{return ($connected);}sub setDisconnected{($connected=
(0x0477+ 6066-0x1c29));}sub __handleRedisErrorIfPossible{(my $response=shift (@_
));if (($response=~ /LOADING Redis is loading the dataset in memory/ )){
resendWaitingCommands ();return ((0x02a8+ 8435-0x239a));}elsif (($response=~ /ERR unknown command/ )
){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x75\x6e\x6b\x6e\x6f\x77\x6e\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x232b+ 283-0x2446)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67"));shift (@waitingCommandList);shift (
@sendCommandList);resendWaitingCommands ();return ((0x0de6+ 3456-0x1b65));}elsif
 (($response=~ /Error compiling script/ )){main::nxexit ((0x01b6+ 6514-0x1b28));
}elsif (($response=~ /Error running script/ )){main::nxexit (
(0x17ba+ 3647-0x25f9));}elsif (($response=~ /WRONGTYPE/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x74\x79\x70\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x0ed2+ 3850-0x1ddc)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x08a2+ 6337-0x2162))
;}elsif (($response=~ /ERR wrong number of arguments/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x72\x6f\x6e\x67\x20\x6e\x75\x6d\x62\x65\x72\x20\x6f\x66\x20\x61\x72\x67\x75\x65\x6d\x6e\x74\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20"
.$waitingCommandList[(0x068c+ 5918-0x1daa)]).
"\x2e\x20\x53\x6b\x69\x70\x70\x69\x6e\x67\x2e"));shift (@waitingCommandList);
shift (@sendCommandList);resendWaitingCommands ();return ((0x01d0+ 496-0x03bf));
}elsif (($response=~ /NOSCRIPT No matching script/ )){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x72\x65\x71\x75\x65\x73\x74\x65\x64\x20\x73\x63\x72\x69\x70\x74\x20\x27"
.$waitingCommandList[(0x0073+ 5957-0x17b8)]).
"\x27\x20\x6e\x6f\x74\x20\x66\x6f\x75\x6e\x64\x20\x69\x6e\x20\x64\x61\x74\x61\x62\x61\x73\x65\x2e"
));shift (@waitingCommandList);shift (@sendCommandList);
NXRedisScript::loadAllScriptsToDb ();return ((0x1971+ 3038-0x254e));}return (
(0x0a2c+ 4561-0x1bfd));}sub saveRedisPid{(my $pidFile=getRedisPidFile ());(my $PID_FH
=main::nxopen ($pidFile,(($NXBits::O_WRONLY+$NXBits::O_CREAT)+$NXBits::O_TRUNC),
(($NXBits::UserReadWrite+$NXBits::GroupRead)+$NXBits::OthersRead)));if (defined 
($PID_FH)){main::nxwrite ($PID_FH,$ $);
 main::nxclose ($PID_FH);if (
main::effectiveUserIsAdministrator ()){my ($errorMsg);if ((
Common::NXFile::setOwnershipForUserNX ($pidFile,(\$errorMsg))==(-
(0x0acb+ 1664-0x114a)))){Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x73\x65\x74\x20\x6f\x77\x6e\x65\x72\x73\x68\x69\x70\x20\x66\x69\x6c\x65\x20\x27"
.$pidFile)."\x27\x20").$errorMsg)."\x2e"));}}}else{(my $error=
libnxh::NXGetErrorName ());Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x43\x61\x6e\x6e\x6f\x74\x20\x6f\x70\x65\x6e\x20\x66\x69\x6c\x65\x20\x74\x6f\x20\x73\x61\x76\x65\x20\x72\x65\x64\x69\x73\x20\x73\x65\x72\x76\x65\x72\x20\x70\x69\x64\x2e\x20\x45\x72\x72\x6f\x72\x20\x69\x73\x20"
.$error)."\x2e"));}}sub checkIfLastOperationWentOk{($errorDuringLastCommand=
(0x03ab+ 3309-0x1098));(my $result=get ());if ((($result ne (""))and (
$errorDuringLastCommand==(0x040f+ 7331-0x20b2)))){return ((0x1522+ 3506-0x22d3))
;}return ((0x0216+ 3980-0x11a2));}sub checkIfSubscriptionShouldBeStarted{if ((
$serverInit==(0x098f+ 2197-0x1224))){return ((0x15df+ 2732-0x208a));}elsif (
Server::isDaemonProcess ()){return ((0x1702+ 303-0x1830));}else{return (
(0x1293+ 4601-0x248c));}}sub setServerType{(my $type=shift (@_));(my $name=(""))
;sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if ((($oldName eq 
(""))or ($oldName eq "\x6e\x6f\x74\x20\x73\x65\x74"))){($name=$type);}else{(
$name=(($oldName."\x20").$type));}($name=main::urlencode ($name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}sub unsetServerType{(my $type=shift (@_));(my $name=(""));
sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x67\x65\x74\x6e\x61\x6d\x65\x0a"
);(my $oldName=get ());($oldName=main::urldecode ($oldName));if (($oldName=~ /$type/ )
){($name=$oldName);($name=~ s/ \b$type\b// );($name=~ s/\b$type\b *// );if ((
$name eq (""))){($name="\x6e\x6f\x74\x20\x73\x65\x74");}($name=main::urlencode (
$name));sendToDb (((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x63\x6c\x69\x65\x6e\x74\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x2c\x6b\x65\x79\x3d\x73\x65\x74\x6e\x61\x6d\x65\x2c\x76\x61\x6c\x75\x65\x3d"
.$name)."\x0a"));}}sub handleCommandSuccesful{(my $command=shift (@_));if ((
$command eq (""))){return ((0x09b5+ 6754-0x2417));}if (($command=~ /command=(.*),error=0/ )
){if (($command=~ /command=multi/ )){($multiCommand=(0x020d+ 1279-0x070b));
return ((0x12bd+ 1194-0x1767));}if ((($command=~ /command=exec/ )and (
$multiCommand>(0x0fd4+ 903-0x135b)))){splice (@sendCommandList,
(0x1ec9+ 1477-0x248e),($multiCommand+(0x03c9+ 4704-0x1628)));($multiCommand=
(0x1a09+ 1630-0x2067));return ((0x13da+ 1121-0x183b));}if (($multiCommand>
(0x01d0+ 6025-0x1959))){(++$multiCommand);return ((0x01ba+ 7206-0x1de0));}(my $firstSendCommand
=__getCommandNameFromLine ($sendCommandList[(0x1a1f+ 2168-0x2297)]));if ((
$command=~ /command=(.*),error/ )){(my $receivedCommand=$1);if ((
$receivedCommand eq $firstSendCommand)){shift (@sendCommandList);return (
(0x0920+ 7522-0x2682));}else{Logger::warning (((((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x55\x6e\x65\x78\x70\x65\x63\x74\x65\x64\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x72\x65\x73\x70\x6f\x6e\x73\x65\x20\x27"
.$command)."\x27\x2e\x20\x57\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x27").
$firstSendCommand)."\x27\x2e"));(my $secondSendCommand=__getCommandNameFromLine 
($sendCommandList[(0x08c9+ 583-0x0b0f)]));if (($receivedCommand eq 
$secondSendCommand)){Logger::warning (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x52\x65\x73\x70\x6f\x6e\x73\x65\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$firstSendCommand).
"\x27\x20\x69\x73\x20\x6d\x69\x73\x73\x69\x6e\x67\x2e\x20\x50\x72\x6f\x63\x65\x65\x64\x20\x77\x69\x74\x68\x20\x73\x65\x63\x6f\x6e\x64\x20\x69\x6e\x20\x6c\x69\x6e\x65\x2e"
));shift (@sendCommandList);shift (@sendCommandList);return (
(0x1e86+ 1236-0x235a));}return ((0x15da+ 4312-0x26b1));}}}elsif ((($command=~ /command=(.*),error=(\d+)/ )
or ($connected==(0x1822+ 278-0x1938)))){if ((__handleRedisErrorIfPossible (
$response)==(0x0a69+ 5375-0x1f67))){return ((0x2149+ 1239-0x261f));}return (
(0x07d9+ 5820-0x1e95));}}sub commandMonitor{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x6d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x6d\x6f\x6e\x69\x74\x6f\x72\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((0x148d+  35-0x14af)){(my (@ready)=$selector->
can_read ((0x1949+ 4125-0x1dae)));foreach my $fh (@ready){if (($fh eq $readRedis
)){my ($read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));
if ((($bytes_read eq (0x04e9+ 7962-0x2403))or ($bytes_read eq ("")))){
Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x08e2+ 558-0x0b10));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x4d\x6f\x6e\x69\x74\x6f\x72\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);}}}if (
NXShell::isExitRequestReceivedSIGINT ()){$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});$selector->remove ($readRedis);main::nxclose (
$readRedis);($readRedis=(""));($connected=(0x024d+ 8600-0x23e5));return ((""));}
}}sub commandDebug{(my $param=shift (@_));(my (@params)=split ( / / ,$param,
(0x192b+ 3335-0x2632)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x3a\x20"
.join ($",@params))."\x2e"));(my $command=shift (@params));(my $key=shift (
@params));if (($command eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x43\x6f\x6d\x6d\x61\x6e\x64\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x1dc0+ 603-0x201b));}(my $redisCommand=((
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d".$command).
"\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62"));if (($key ne (""))){(
$redisCommand.=("\x2c\x6b\x65\x79\x3d".$key));}foreach my $field (@params){(
$redisCommand.=("\x2c\x66\x69\x65\x6c\x64\x3d".$field));}($redisCommand.="\x0a")
;sendToDb ($redisCommand);main::nxwrite (main::nxgetSTDOUT (),(get ()."\x0a"));}
sub commandInfo{Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x69\x6e\x66\x6f\x20\x72\x65\x64\x69\x73\x2e"
);sendToDb (
"\x63\x6f\x6d\x6d\x61\x6e\x64\x3d\x69\x6e\x66\x6f\x2c\x73\x65\x72\x76\x69\x63\x65\x3d\x64\x62\x0a"
);(@sendCommandList=());while ((my (@ready)=$selector->can_read (
(0x1145+ 5855-0x1c6c)))){foreach my $fh (@ready){if (($fh eq $readRedis)){my (
$read_buf);(my $bytes_read=main::nxread ($readRedis,(\$read_buf),32768));if (((
$bytes_read eq (0x0359+ 2452-0x0ced))or ($bytes_read eq ("")))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x73\x6f\x63\x6b\x65\x74\x20\x77\x61\x73\x20\x63\x6c\x6f\x73\x65\x64\x2e"
);$selector->remove ($readRedis);$selector->remove ($$NXBegin::parser{
"\x53\x69\x67\x6e\x61\x6c"});main::nxclose ($readRedis);($readRedis=(""));(
$connected=(0x0be9+ 4774-0x1e8f));return ((""));}else{(my $response=$read_buf);
while ((($bytes_read==32768)or (not (($read_buf=~ /\n$/ ))))){($bytes_read=
main::nxread ($readRedis,(\$read_buf),32768));($response.=$read_buf);}
Logger::debug3 (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x49\x6e\x66\x6f\x20\x72\x65\x74\x75\x72\x6e\x3a\x20"
.$response)."\x2e"));main::nxwrite (main::nxgetSTDOUT (),$response);closeDb ();
return;}}}}}sub commandScript{(my $param=shift (@_));(my (@params)=split ( / / ,
$param,(0x1580+ 1761-0x1c61)));shift (@params);Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x48\x61\x6e\x64\x6c\x69\x6e\x67\x20\x73\x63\x72\x69\x70\x74\x3a\x20"
.join ($",@params))."\x2e"));(my $scriptName=shift (@params));if (($scriptName 
eq (""))){Logger::error (
"\x4e\x58\x52\x65\x64\x69\x73\x44\x65\x62\x75\x67\x3a\x20\x53\x63\x72\x69\x70\x74\x20\x6e\x61\x6d\x65\x20\x63\x61\x6e\x6e\x6f\x74\x20\x62\x65\x20\x65\x6d\x70\x74\x79\x2e"
);main::nxexit ((0x0231+ 339-0x0384));}main::nxrequire (
"\x4e\x58\x52\x65\x64\x69\x73\x53\x63\x72\x69\x70\x74");(my (@args)=());(my $returnValue
=NXRedisScript::executeScript ($scriptName,(\@args),(\@params)));if ((
$scriptName eq 
"\x67\x65\x74\x41\x6c\x6c\x44\x61\x74\x61\x46\x72\x6f\x6d\x53\x65\x74")){(
$returnValue=~ s/^"// );($returnValue=~ s/"$// );(my (@data)=split ( /" "/ ,
$returnValue,(0x17a7+ 2737-0x2258)));foreach my $singleData (@data){(my (%hash)=
split ( / / ,$singleData,(0x0b10+ 199-0x0bd7)));foreach my $key (keys (%hash)){
main::nxwrite (main::nxgetSTDOUT (),((($key."\x3a\x20").$hash{$key})."\x0a"));}
main::nxwrite (main::nxgetSTDOUT (),"\x0a");}}else{main::nxwrite (
main::nxgetSTDOUT (),$returnValue);}}sub checkFailCounter{(++$failCounter);if ((
$failCounter==(0x0305+ 1861-0x0a49))){Logger::debug (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x6f\x6e\x63\x65\x20\x63\x6f\x6e\x65\x6e\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}elsif (($failCounter==(0x1bfa+ 2035-0x23eb))){Logger::warning (
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x74\x77\x69\x63\x65\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x2e"
);}if (($failCounter>(0x0eab+ 826-0x11e3))){if (($finalizeProcessStarted==
(0x015b+ 7627-0x1f25))){Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x20\x61\x6c\x72\x65\x61\x64\x79\x20\x73\x74\x61\x72\x74\x65\x64\x2e"
));}else{Logger::error (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x66\x61\x69\x6c\x65\x64\x20\x63\x6f\x6e\x6e\x65\x63\x74\x69\x6f\x6e\x20\x74\x6f\x20\x64\x62\x20"
.$failCounter).
"\x20\x74\x69\x6d\x65\x73\x2e\x20\x43\x6c\x6f\x73\x69\x6e\x67\x20\x70\x72\x6f\x63\x65\x73\x73\x2e"
));main::nxexit ((0x1363+ 1530-0x195d));}}return;}sub forceCloseRedisClient{(
$connected=(0x01ca+ 2239-0x0a88));closeDb ();}sub 
checkFailCounterAndCloseIfNeeded{if (($serverInit==(0x079c+ 1126-0x0c01))){
return;}if (($failCounter>(0x0acc+ 3131-0x1706))){shift (@sendCommandList);
forceCloseRedisClient ();}checkFailCounter ();}sub cleanCommandList{while ((
scalar (@sendCommandList)>(0x1776+ 2112-0x1fb6))){get ();}}sub isSaveDone{(my $response
=shift (@_));if ((($response eq "\x4f\x4b")or ($response eq 
"\x42\x61\x63\x6b\x67\x72\x6f\x75\x6e\x64\x20\x73\x61\x76\x69\x6e\x67\x20\x73\x74\x61\x72\x74\x65\x64"
))){return ((0x1618+ 3686-0x247d));}return ((0x0b1b+ 5923-0x223e));}sub 
waitForAllCommands{while ((scalar (@sendCommandList)>(0x0380+ 7030-0x1ef6))){(my $command
=__getCommandNameFromLine ($sendCommandList[(0x0d02+ 3732-0x1b96)]));
Logger::debug (((
"\x4e\x58\x52\x65\x64\x69\x73\x3a\x20\x77\x61\x69\x74\x69\x6e\x67\x20\x66\x6f\x72\x20\x63\x6f\x6d\x6d\x61\x6e\x64\x20\x27"
.$command)."\x27\x2e"));get ();}}sub doNotCloseRedisThreadsOnExit{(
$doNotCloseRedisThreadsWhenFreePerl=(0x009b+ 675-0x033d));}NXMsg::register_error
 ("\x4e\x58\x52\x65\x64\x69\x73",
"\x65\x43\x4d\x44\x43\x61\x6e\x6e\x6f\x74\x43\x6f\x6e\x74\x69\x6e\x75\x65\x4e\x78\x73\x65\x72\x76\x65\x72\x53\x68\x75\x74\x64\x6f\x77\x6e"
,(0x0440+ 946-0x05fe));"\x3f\x3f\x3f";
